// ****************** Copyright Header ************************************
// WebWisdom JavaScript Shared Browser Version 3.0
// Copyright 1999 Syracuse University and WebWisdom.com
// Author: Geoffrey C. Fox
// Contact: support@webwisdom.com
//
// Reproduction of this software without this Copyright Header
// is prohibited and it constitutes a violation of
// the SU and WebWisdom.com Copyright (a federal felony).
//
// This software cannot be incorporated into any commercial
// product, or a product supporting commercial activity,
// without first obtaining a license from WebWisdom.com
// E-mail license@webwisdom.com to apply.
// *********** End of Copyright Header ************************************
//
//***********************Tango JavaScript API******************

var Tango_agent = null; // handle to Tango methods
var Tango_MASTER = 0; 
var Tango_NONMASTER = 1; 
var Tango_NONE = 2;
var WW_tangostatus = Tango_NONE;

var WW_geteventmode = 2; // =0 Get events from examination of page
// =1 Get events as nonmaster from Tango messages
// =2 Get events as master or nonmaster from reading archive event list

function Tango_register(win)	{	// Register with Tango

	Tango_agent=Packages.webwisdom.tango.TAgentJS.createTAgentJS(win);
	if(Tango_agent!=null)
		Tango_agent.setDbgModeJS(false);
		
}	// End Tango_register(win)

function Tango_masterChanged(isM,mNa)	{

	WW_print("Tango Net Master Changed status " + isM + " Name " + mNa);
	WW_addnewperson(mNa+"",0,1);
	
}	// End Tango_masterChanged(isM,mNa)

function Tango_participantJoined(pNa)	{

	WW_print("Tango Participant Joined " + pNa);
	WW_addnewperson(pNa+"",1,0);
	return;

}	// End Tango_participantJoined(pNa)

// newname is name
// addtoreplace = 0 implies if exists already just update properties
// addtoreplace = 1 implies deactivate original duplicate name
// statusflag = 0 ordinary =1 netmaster =2 master
function WW_addnewperson(newname,addorreplace,statusflag)	{

	var addname = true;
	var dosomething = false;
	for(var m=0; m < WW_numjssbusers; m++)	{
		if( newname != WW_jssbusers[m].name )
			continue;
		if( !WW_jssbusers[m].active)
			continue;
		if( addorreplace == 0 )	{ // Just update
			addname = false;
			if( statusflag == 2 )	{
				if(WW_jssbusers[m].masterstatus)
					break;
				dosomething = true;
				WW_jssbusers[m].masterstatus = true;
				WW_mastername = newname;
			}
			if( statusflag == 1 )	{
				if(WW_jssbusers[m].netmaster)
					break;
				dosomething = true;
				WW_jssbusers[m].netmaster = true; }
			break;
		}
		WW_jssbusers[m].active = false;
		var today = new Date();
		WW_jssbusers[m].endtime = today.getTime();
		break;
	}
	if( addname )	{
		dosomething = true;
		WW_jssbusers[WW_numjssbusers] = new WW_jssbparticipant(newname,WW_numjssbusers+1);
		if( statusflag == 2 )	{
			WW_jssbusers[WW_numjssbusers].masterstatus = true;
			WW_mastername = newname;
		}
		if( statusflag == 1 )
			WW_jssbusers[WW_numjssbusers].netmaster = true;
		++WW_numjssbusers;
	}
	if( !dosomething )
		return;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writesharedformlayer();
		WW_dialogwindow.WW_writeloadpagelayer();
		WW_dialogwindow.WW_writenetworklayer(); }

}	// End WW_addnewperson(newname,addorreplace,statusflag)

function Tango_participantLeft(pNa)	{

	WW_print("Tango Participant Left " + pNa);
	pNa = pNa + "";
	for(var m=0; m < WW_numjssbusers; m++)	{
		if( pNa != WW_jssbusers[m].name )
			continue;
		if( WW_jssbusers[m].active)	{
			WW_jssbusers[m].active = false;
			var today = new Date();
			WW_jssbusers[m].endtime = today.getTime();
			break;
		}
	}
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writesharedformlayer();
		WW_dialogwindow.WW_writeloadpagelayer();
		WW_dialogwindow.WW_writenetworklayer(); }
	
}	// End Tango_participantLeft(pNa)

function Tango_audioRequested(isR)	{

	WW_print("Tango_audioRequested(" + isR + ")");
	
}

function Tango_getMasterName()	{ // Return Master Name as a String

	if(Tango_agent!=null)	{
		return (Tango_agent.getMasterNameJS()+""); }
	return '';

}	// End Tango_getMasterName()

function Tango_getUserName()	{ // Return This User's Name as a String

	var uname = '';
	if(Tango_agent!=null)
		uname = Tango_agent.getUserNameJS();
	WW_print("Tango User Name " + uname);
	return (uname + "");

}	// End Tango_getUserName()

// Update list of participants
// Only good to use by Master and even thwen loses Netmaster status
function Tango_getParticipantNames()	{ 

	if(Tango_agent==null)
		return;
	var partarray = Tango_agent.getParticipantNamesJS(); // // Get Participant Names as an Array of Strings
	var numpart = partarray.length;
	WW_print(numpart + ' participants revealed');
	if( numpart <= 0 )
		return;
	var mname = Tango_getMasterName() + "";
	for(var n=0; n < numpart; n++ )	{
		var pname = partarray[n];
		var gotit = false;
		for(var m=0; m < WW_numjssbusers; m++)	{
			if( !WW_jssbusers[m].active )
				continue;
			if( pname != WW_jssbusers[m].name )
				continue;
			gotit = true;
			break;
		}
		if(gotit)
			continue;
		WW_jssbusers[WW_numjssbusers] = new WW_jssbparticipant(pname,WW_numjssbusers+1);
		++WW_numjssbusers;
	}
	for(var m=0; m < WW_numjssbusers; m++)	{
		if( !WW_jssbusers[m].active )
			continue;
		var gotit = false;
		for(var n=0; n < numpart; n++ )	{
			if( WW_jssbusers[m].name == partarray[n] )
				gotit =true;
		}
		if( !gotit )	{
			WW_jssbusers[m].active = false;
			continue;
		}
		if( WW_jssbusers[m].name == mname )
			WW_jssbusers[m].netmaster = true;
		if( WW_jssbusers[m].name == WW_mastername )	{
			WW_jssbusers[m].netmaster = true;
			WW_jssbusers[m].masterstatus = true;
		}
			
	}
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writesharedformlayer();
		WW_dialogwindow.WW_writeloadpagelayer();
		WW_dialogwindow.WW_writenetworklayer(); }

	return;

}	// End Tango_getParticipantName()

function WW_print(message)	{ // Output to Java Console

	WW_setjavaconsole(message);
	return;

}	// end WW_print(message)
			  
function WW_wisdomcleanup()	{ // Called as unload handler

	if(WW_isitaspawnedwindow(WW_spawnedparent))	{
		import WW_spawnedparent.WW_spawnedparentclose;
		if( (WW_operatingmode==3) && WW_closemostwindows )	{
			import WW_spawnedparent.WW_cardhandalignfocus;
			WW_cardhandalignfocus(-2);
		}
		WW_spawnedparentclose(); }
	if(WW_isitaspawnedwindow(WW_topcontrolwindow))	{
		import WW_topcontrolwindow.WW_barclose;
		WW_barclose(); }
	if(WW_isitawindow(WW_dialogwindow))
		WW_dialogwindow.close();
	if(WW_isitawindow(WW_reviewwindow))
		WW_reviewwindow.close();
	if(WW_isitawindow(WW_statuswindow))
		WW_statuswindow.close();
	if(WW_closemostwindows)	{
		if(WW_isitawindow(WW_historyparent))
			WW_historyparent.close();
		if(WW_isitawindow(WW_historytarget))
			WW_historytarget.close();
		if(WW_isitawindow(WW_consolewindow))
			WW_consolewindow.close();
		if(WW_isitawindow(WW_eventpropwindow))
			WW_eventpropwindow.close();
	}
	if( WW_deletepersonalbookmarks )	{
		for(var m=0; m < WW_numpersonalbookmarks; m++)	{
			var local = WW_personalbookmarkarray[m];
			if(!local.active)
				continue;
			if(WW_isitawindow(local.handle))
				local.handle.close();
		}
	}
	if( WW_deletesystembookmarks )	{
		for(var m=0; m < WW_numsystembookmarks; m++)	{
			var local = WW_systembookmarkarray[m];
			if(!local.active)
				continue;
			if(WW_isitawindow(local.handle))
				local.handle.close();
		}
	}

	if(Tango_agent != null)
		Tango_agent.exitJS();
	return true;
	
}	// End  WW_wisdomcleanup()

// recp is a JavaScript array containing users who should receive data
function Tango_selectiveSend(recp,data)	{

	if(Tango_agent!=null)
		Tango_agent.selectiveSendJS(recp,data);

}	// End Tango_selectiveSend(recp,data)

function Tango_send(data) {	//Tango_send - sends string to the Tango system 

	if(Tango_agent!=null)
		Tango_agent.sendJS(data);

}	// End Tango_send(data)

//Tango_receive - called by the Tango system, when an message arrives,
//body of this function should be implemented by the script developer
function Tango_receive(datainput)	{	// Receive events from the outside

// Restart Tango Non Master if Necessary
	if(WW_geteventmode == 2 )
		return true;
	++WW_neverdone;
	if( WW_restartspawnedwindow() )
		return true;
	var datafirst = datainput.toString() + "";
	receivedevent = new WW_gottenevent();
	receivedevent.targetname = WW_username;
	receivedevent.majorevent = WW_numberurl;
	WW_getevent(datafirst,receivedevent);
	WW_Tangostoreevent(receivedevent);
	return true;
	
}	// End Receive Message from Tango Tango_receive(datainput)

	

//********************end of Tango JavaScript  API************************

/*	Find Absolute Paths */
var endofpathname = document.URL.lastIndexOf("/") + 1;
var WW_thisdocumentURLpath = document.URL.slice(0,endofpathname);

var WW_operatingmode = 0; // =0 Shared Browser =1 WebWisdom =2 Shared form =3 Play the Game
var WW_countconsolemessages = 0; // Counts Console messages
WW_consoleentry = new Array(); // Store Console Messages

// Define Images in ControlBar
var WW_defaultreviewmode = 0; // =0 display review =1 preview =2 WebWisdom =3 yourhand =4 console
var WW_reviewmode = WW_defaultreviewmode;
var WW_reviewfilename = new Array('review','preview','ww','yourhand', 'console');
var WW_reviewmessage = new Array('Review thumbnails','Preview Thumbnails','Presentation Control','Your Hand', 'Console');
var WW_statusmode =0; // =0 display CloneURL =1 display Status = 2 display Console
var WW_statusfilename = new Array('cloneURL','status','console');
var WW_statusmessage = new Array('Clone Current Browser Window','Status of Participants','Console');
var WW_defaultmainurl = 'main.gif'; // Image for Main window
var WW_mainurl = WW_defaultmainurl;

var WW_majoreventprocess = 0 // =0 humming away =1 Major Event being Processed

// Set Default Favorites *************************************************
WW_listoffavorites = new Array('http://trurl.webwisdom.com/tango2-rel/tango-2.0/data/sjsb/present/index.html','http://www.webwisdom.com/Resources/resources.html','http://biology.ncsa.uiuc.edu/','http://www.npac.syr.edu/users/gcf/byarea0.html');
var WW_favorite_count = WW_listoffavorites.length;
var WW_selectedfavorite = 0;
var WW_userinput = "http://www.webwisdom.com";
var WW_globalurl = WW_thisdocumentURLpath + "StartTangoJSSBHome.html";
var WW_totalpage = WW_thisdocumentURLpath + "ActualTangoJSSB.html"

WW_operatingmode = 0; // Indicates that is General Shared Browser
if( WW_operatingmode == 3 )	{
	WW_globalurl = WW_thisdocumentURLpath + "StartTangoJSGamingHome.html";
	WW_totalpage = WW_thisdocumentURLpath + "ActualTangoJSGaming.html"
	WW_defaultreviewmode = 3; // Review Window is Hand
	WW_statusmode = 1; // Status Window is Console
	WW_defaultmainurl = 'cardtable.gif';	// Change Icon for Main window
	WW_listoffavorites.splice(0,WW_listoffavorites.length ,WW_thisdocumentURLpath + 'game/index.html','http://www.npac.syr.edu/users/gcf/sbwisdom1/game/index.html','http://www.npac.syr.edu',WW_globalurl);
	WW_favorite_count = WW_listoffavorites.length;
}

var WW_nothingdone = true; // Flag to reject early update events
var WW_debugmode = true; // true to enable debug text line
var WW_nomoremessages = 0;
var WW_firsturl = WW_globalurl;
var WW_targeturl = WW_globalurl;
var WW_countspawnedtries = 0;
var WW_oldstem = '';
var WW_newstem = '';
var WW_currentfullurl = '';
var WW_spawnedparent = null;
var WW_treasuredwindow = null;
var WW_freewindow = null;
var WW_expectedurl = '';
var WW_Tango_number = 0;
var WW_neverdone = 0;
var WW_doublecheckonthis = 0; // If nonzero this minor event contains content of last "heart"

var WW_numberurl =0;
WW_majorevent = new Array();
WW_majorevent[0] = {};
WW_majorevent[0].label = 'Nothing Set Yet';

WW_eventrecord = new Array(); // Record Events on Input and Output

// Control Processing of Received Events
var WW_inputsequence = 'unset'; // Current input event stream label (typically master sourceflag)
var WW_inputgrouplabel = ''; // Current major event group on input stream

// Control Processing of Events sent out on WW_localflag (a random number) stream
var WW_localflag = 1000000.*Math.random();
WW_localflag = parseInt(WW_localflag)
WW_localflag = WW_localflag.toString(); // Flag to define group produced by this as master

WW_eventindicators = new Array();
var WW_numeventindicators = 0; // Count and Array for Major Event Indicators
var WW_numonunload = 0;
WW_onunloadevent = new Array();
var WW_numdynamictangoflag =0; // Number of undefinitions of Dynamic Tango Flags
WW_dynamictangoflagevent = new Array();
var WW_numwisdomregister = 0;
WW_wisdomregisterevent = new Array();
var WW_numcompleteddocuments = 0; // Number of Document completions
WW_completeddocumentsevent = new Array();

var WW_tangogrouplabel = 'Initial Group'; // Group Label on Current Generation Stream
var WW_tangosequencenumber = -1; // Output Sequence Number within Current Stream
WW_labelstream = new Array();
WW_newtangolabel(WW_localflag,'Initial Group');
var WW_beginningoftime = WW_labelstream[0].time;

var WW_localnetflag = WW_localflag +'/net';
var WW_controlgroup = WW_beginningoftime;
var WW_controlsequence = -1;

var WW_clockunits = 4; // 1 (2 second) 2(1 second) 4 (.5 second cycle)
var WW_barmessagelimit = -1; // If positive remove bar message at this time in clock ticks

var WW_spawnedwindowwidth = 800;
var WW_spawnedwindowheight = 600;
if( WW_operatingmode==3 )
	WW_spawnedwindowheight = 450;
var WW_ignoreresize = 2; // =1 Confirmation Box, = 0 Never Accept, = 2 Always accept Resize
var WW_spawnedparentdone = false;

var WW_numallevents =0; // Total number of events stored
var WW_numpointereventsdone = 0; // Current DHTML(pointer) events done
var WW_numeventsdone =0;	// Current event number reached
var WW_keeplastpointerevent = 0; // Last Pointer Event
var WW_keeplastlocationevent = 0; // Last Location Event
var WW_keeplastparameterevent = 0; // Last Parameter Event
var WW_keeplastbookmarkevent = 0; // Last Bookmark Event
var WW_resetpointerto = -1; // if >0 set pointer in DHTML window according to this minor event
var WW_replaynumber = 0;
var WW_parameterssent = false;

var WW_includeeventlist = true; // If true. Include Event Information in History HTML
var WW_includeeventdata = true; // If true, Include Event Information in History archive
var WW_replaylocally = false; // if true, in replay mode play material locally as well as remotely
var WW_acceptmasterforms = true; // if true, nonmaster accepts full form updates from master
var WW_acceptformsnippets = true; // If false, nonmaster ignores form components from master
var WW_listformstuff = true; // if true put form stuff in history lists
var WW_listpointerstuff = true; // if true put pointer stuff in history lists
var WW_incrementalarchive = false; // If true doo incremental -- not full archives
var WW_lasteventarchived = 0; // Last Event saved in History Archive
var WW_lastmajoreventarchived =0; // Last Major Event Number saved in History Archive

var WW_enforceformcommands = false; // If true enforce masters wishes on client
var WW_sendscroll = true; // If true, scrolling events are sent
var WW_usescroll = false; // If true, nonmaster will process scroll events
var WW_allowformclick = true; // If false, do not allow nonmaster to click monitored forms
var WW_allowurlclick = false; // If false, do not allow nonmaster to click links on shared browser
var WW_captureallclicks = true; // If true, all clicks are captured on master side
var WW_capturelinkclicks = true; // If true, capture clicks on links on master, true if WW_captureallclicks true
var WW_captureallmouseoverout = false; // True if capture all Mouse over/out events on master side
var WW_capturelinkmouseoverout = false; // true if WW_captureallmouseoverout true -- in general true if capture mouse over/out on links on master

var WW_allowonunload = true; // Allow shared browser to overwrite onunload handler

// Set Click Handling on Capture
var WW_clicktrapped = true;
var WW_clicknottrapped = true;
var WW_changeform = true;
var WW_changenotform = true;

var WW_badloadlimit = 0;
var WW_notsobadloadlimit = 0;
var WW_waitforformtoact = 0;

var WW_lasteventtoreplay = -1; // User specifies this as last minor event to replay
var WW_finalreplayevent = -1; // In replay loop, this is actually last event
var WW_previousreplayevent = -1; // previous event replayed
var WW_realtime = -1; // Actual time of last event from replay list
var WW_virtualtime = -1; // Original time of last event from replay list
var WW_minimumtimeinterval = 2000; // Minimum time interval Between Events
var WW_lasttowaitfor = 0; // Control Display of Progress on Bar
var WW_lastwaitedevent = -1; // Eventv last displayed
var WW_minortimeinterval = -1; // If positive, the time goal between minor events
var WW_majortimeinterval = -1; // If positive, the time goal between major events
var WWTango_acceptmasterstyle = true; // Control Pointer behavior on non master
var WWTango_canchangepointer = false; // Control Pointer behavior on non master

var WW_absolutesnoopimageindex = -1; // Index into WW_majorevent array
var WW_previewincrement =1;
var WW_snoopfactor = 0.75;
var WW_snoopimagewidth= 300.;
var WW_trackreview = true; // if true track review/preview
var WW_reviewoption = true; // if true review and if false preview
var WW_imageheuristicmaxno = 10000; // If < 0 unsets Image Thumbnail Heuristics
var WW_imageheuristicminchar = 3; // Number must have at least this many characters
var WW_imageheuristictext = ''; // If non empty, insist Image URL contains this
var WW_nextprevheuristicmaxno = 10000; // If < 0 unsets Next/Prev Heuristics
var WW_nextprevheuristicminchar = 3; // Number part of Next/Prev URL must have at least this many characters
var WW_nextprevheuristictext = ''; // If non empty, insist number part of URL contains this
var WW_nextheuristicurl = '';
var WW_prevheuristicurl = ''

var WW_resizeoption = "yes"; // Resize Option for Main Page
var WW_closemostwindows = true; // If true Close Most Windows at end of session
var WW_keepreviewwindow = false; // If true keep review window open even if seemingly irrelevant
var WW_tangoboss = self;
var WW_dialogwindow = null;
var WW_reviewwindow = null; // Also Preview
var WW_historytarget = null;
var WW_historyparent = null;
var WW_statuswindow = null; // Used in Games
var WW_consolewindow = null;
var WW_eventpropwindow =null; // holds event window
var WW_eventtoprint = null; // Holds Event to Print
var WW_eventparmpage = null; // Layer with event processing options
var WW_consoleparmpage = null; // Layer with console details
var WW_displayconfiglayer = null; // Layer in Dialog Window for Configuration Display
var WW_consolehandlerparm = -1;

// Bookmarks
var WW_selectedsystembookmark = -1;
var WW_selectedsystembookmarkuser = 0;
var WW_numsystembookmarks = 0;
var WW_selectedpersonalbookmark = -1;
var WW_numpersonalbookmarks = 0;
var WW_deletesystembookmarks = true;
var WW_deletepersonalbookmarks = true;
var WW_personalbookmarkarray = new Array();
var WW_systembookmarkarray = new Array();

// Download and Timing Data ************************
var WW_numstoredownloadtests = 0;
var WW_storedownloadtests = new Array();
var WW_largeimagestem = WW_thisdocumentURLpath + "largeimage1/"; // holds 1.jpg to 10.jpg
var WW_smallimagestem = WW_thisdocumentURLpath + "smallimage1/"; // holds 1.gif to 10.gif

//	Configuration Setup
var WW_deleteconfigflag = false; // Cant Delete Configuration unless true
WW_configlabel = new Array('Master','Master Only','Both');
var WW_numconfigs = 2;
WW_configarray = new Array();
WW_setconfig(0,'default');

// Set GCF Favorites *************************************************

WW_listoffavorites.splice(0,WW_listoffavorites.length,'http://maryland.webwisdom.com',WW_thisdocumentURLpath + 'examples/click.html',WW_thisdocumentURLpath + 'present/javalang99/index.htm',WW_thisdocumentURLpath + 'game/index.html',WW_thisdocumentURLpath + 'game/indexframed.html','http://biology.ncsa.uiuc.edu/');
WW_favorite_count = WW_listoffavorites.length;
WW_selectedfavorite = 0;
WW_userinput = "http://www.npac.syr.edu/users/gcf/byarea0.html";
WW_setconfig(1,'gcf');
var WW_selectedconfig = 0;
WW_configarray[WW_selectedconfig].preferred = true;
WW_switchtofavorites(0);

// Outside layers and Windows ****************
WW_sourcewindow = new Array('WW_dialogwindow','WW_dialogwindow','WW_dialogwindow','WW_dialogwindow','WW_dialogwindow','WW_dialogwindow');
WW_sourceform = new Array('WW_statusform','WW_controlform','WW_loadpageform','WW_historyform','WW_networkform','WW_sharedformform');
var WW_numberofsites = 6;
var WW_numdialogtablayers = 6;
var WW_dialogarg =2; // Default Tab for Dialog
var WW_dialogtabwidth = 120;

// Position Windows on Screen ******************************
var WW_userwindowxpos = 50.;
var WW_userwindowypos = 50.;
WW_userwindowxpos = WW_getCookie("windowxpos",WW_userwindowxpos);
WW_userwindowypos = WW_getCookie("windowypos",WW_userwindowypos);

// Control Bar and its Button ****************************
var WW_barrandomname = 10000.*Math.random();
WW_barrandomname = parseInt(WW_barrandomname);
WW_barrandomname = "TopControlWindow" + WW_barrandomname.toString();
var WW_topcontrolwindow = null;
var WW_launchedbarbutton = 1;
var WW_topcontrolwindowreadytogo = 0;

var WW_processingerrorflag = 0;
var WW_squareimage = new Array('small','smallyellow','smallred');
WW_squaremessage = new Array('Move Control Bar','Minor Event Error; Cleanse Events in Dialog; Look at Console','Major Event Error; Cleanse Events in Dialog; Look at Console');

var maxbuttonbarsize = 9;
var WW_barlayoutsize = 8;
WW_barlayout = new Array(0,1,7,8,2,4,5,6);
WW_buttonspec = new WW_buttonbar();
WW_buttonclone = new WW_buttonbar();
WW_buttonspec.fiveway[5]= -1;
WW_buttonspec.fiveway[6]=3;
WW_buttonspec.message[0]='Main';
WW_buttonspec.message[2]='History or Archive';
WW_buttonspec.message[4]='SetParameters';
WW_buttonspec.message[5]='Blue= New URL; Blue<->Red Heartbeat; Green is Other Event';
WW_buttonspec.message[6]= WW_squaremessage[WW_processingerrorflag];
WW_buttonspec.imageurl[2]='history.gif';
WW_buttonspec.imageurl[4]='dialog.gif';
WW_buttonspec.imageurl[5]='smallsquaretree.gif';
WW_buttonspec.imageurl[6]= WW_squareimage[WW_processingerrorflag] + '.gif';
WW_buttonspec.width[5] = 40;
WW_buttonspec.width[6] = 40;
WW_buttonspec.yesno[1] =0;
WW_buttonspec.yesno[2] =0;
WW_buttonspec.yesno[3] =0;
WW_buttonspec.yesno[4] =0;
WW_buttonspec.width[7] = 40;
WW_buttonspec.height[7] = 20;
WW_buttonspec.width[8] = 40;
WW_buttonspec.height[8] = 20;
WW_buttonspec.imageurl[7]= 'prev.gif';
WW_buttonspec.imageurl[8]= 'next.gif';
WW_buttonspec.message[7]= 'Previous URL in Sequence';
WW_buttonspec.message[8]= 'Next URL in Sequence';
WW_buttonspec.fiveway[7]=0;
WW_buttonspec.fiveway[8]=0;
WW_buttonspec.yesno[7] =0;
WW_buttonspec.yesno[8] =0;

var WW_tangoadminmaster = false; // True if initial master -- canNOT be changed

// The following array is set to do selective send but is only used in "Heartbeat"
// The Heartbeat sending section resets length of this array to zero after updates sent
var WW_waitingparticipantlist = new Array(); // Initially Null Array to hold participants to receive update
var WW_requestupdate =0; // Set to 1 to invoke update request

var WW_tempparticipantlist = new Array(); // Used to send selective in any case

var WW_Tango_randomname = '';
var WW_username = '';
var WW_mastername = '';
var WW_jssbusers  = new Array();

var WW_numjssbusers = 1; // Number of users
var WW_statusoutput = 1; // =1 Local Output; =2 Only Valid for Master and produce status
var WW_statuswork = 0; // =2 Generate Small =1 Generate Large Image Download Test on Loading
var WW_statusveto = 2; // =0 Allow no downloads; =1 just small images; =2 all downloads

WW_jssbusers[0] = new WW_jssbparticipant(WW_username,1);

//	Set Up Game Mode
if( WW_operatingmode == 3 )	{
	WW_buttonspec.message[0] = 'Card Table';
}

//	Variables Controlling Game
var WW_tangogamedealer = false; // True if dealer for game
var WW_dealername = ''; // Name of Dealer if Known
var WW_gamestream = 'Set to Game Stream Label';
var WW_gamegroup = 'Set to Current Game Group';
var WW_gamemovearray  = new Array();	// Count Moves in a Game from this player ( 0 is general 1 .. WW_playernames.length is this player);
var WW_countgames = 0; // Count games with this site as dealer
var WW_tangogameinprogress = false; // If true Game is being played
var WW_tangogametypeloaded = 0; // > 10 if Page supporting Game Loaded
var WW_playernames = new Array();	// Real Players -- Rest of Participants are Observers
var WW_currentcustomplayers = new Array(); // Accumulate Players

WW_mainurl = WW_defaultmainurl;
WW_buttonspec.imageurl[0]= WW_mainurl;

// Called When Page Fully loaded
function WW_tangopageloaded()	{

/* Initial methods for registering in Tango runtime and updating master/non master status */
	Tango_register(window);
	if(Tango_agent!=null)	{
		Tango_agent.addTDataListenerJS(window);
		Tango_agent.addTControlListenerJS(window);
		WW_tangostatus = Tango_NONMASTER;
		if(Tango_agent.isMasterJS())	{
			WW_tangostatus = Tango_MASTER;
			WW_tangoadminmaster = true;
			WW_tangogamedealer = true;
		}
	}

// Following Code must be after Application registered ***************************
	var extrarandomname = 10000.*Math.random();
	extrarandomname = parseInt(extrarandomname);
	WW_Tango_randomname = window.name + extrarandomname;
	WW_geteventmode = WW_tangostatus;
	WW_startspawnedwindow(); // calls WW_setupmasterstuff


// Participant Data **********************
	WW_username = Tango_getUserName();
	WW_mastername = Tango_getMasterName();
	WW_jssbusers[0].name = WW_username;
	if( WW_tangostatus == 0 )	{
		WW_jssbusers[0].masterstatus = true;
		WW_jssbusers[0].netmaster = true;
	}
	if(WW_operatingmode==3)
		WW_dealername = WW_username;
	
//	Ask Master for Update
	if( WW_tangostatus!=0 )
		WW_requestupdate =1;

}	// End WW_tangopageloaded()

// Define participant
function WW_jssbparticipant(name,number)	{

	this.name = name;	// User name from Tango
	this.number = number; // Count+1 in WW_jssbusers
	this.active = true;
	this.masterstatus = false;
	this.netmaster = false;
	var today = new Date();
	this.starttime = today.getTime();
	this.endtime = 0;
	this.numpings = 0; // count ping records
	this.pingrecord = new Array();
	this.lastping = 0;
	this.averageping = 0;
	this.averageskew = 0;
	this.numdownloads = 0; // count download records
	this.downloadrecord = new Array();
	this.numstatusrecords = 0; // count status records
	this.statusrecord = new Array();
	this.statusrecordparms = {}; // Holder for Overall Status Parameters

}	// End WW_jssbparticipant(name,number)

// Return Index into WW_jssbusers array or -1 if nonexistent
function WW_finduserbyname(username)	{

	for( var m=0; m < WW_numjssbusers; m++ )	{
		if( !WW_jssbusers[m].active )
			continue;
		if( WW_jssbusers[m].name == username )
			return m;
	}
	return -1;

}	// End WW_finduserbyname(username)

// Set up in standardmenu one of our standard menus from current list with selectedname selected
// Select current user if selectedname not available
function WW_makeusermenu(standardmenu,selectedname)	{

	var mone =0;
	var count = 0;
	if( selectedname == 'WWSetMultiple' )	{
		mone = 1;
		count = 1;
		standardmenu.options[0] = 'Everybody';	
	}
	else	{
		standardmenu.menuselection = 0;
	}
	for( var m=mone; m < WW_numjssbusers; m++ )	{
			if( !WW_jssbusers[m].active )
				continue;
			if( selectedname == 'WWnetmaster' )	{
				if(!WW_jssbusers[m].netmaster)
					continue;
			}
			else	{
				if( WW_jssbusers[m].name == selectedname )
					standardmenu.menuselection = count;
			}
			standardmenu.options[count] = WW_jssbusers[m].name;
			++count;
	}
	standardmenu.count =count;
	return;

}	// End	WW_makeusermenu(standardmenu,selectedname)

 // Initialization dependent on master status
function WW_setupmasterstuff()	{ 

	WW_statusmode =0;
	WW_replaylocally = true;
	if( WW_tangostatus==0 )	{
		WW_statusmode = 1;
		WW_replaylocally = false;
	}
	if( (WW_tangostatus  == 0) && (WW_operatingmode <= 2) )
		WW_statusmode = 2;
	WW_reviewmode = WW_defaultreviewmode;
	if((WW_tangostatus  == 0) && (WW_defaultreviewmode==0))
		WW_reviewmode = 1;
	WW_reviewoption = true;
	if( WW_tangostatus  == 0 )	{ // Master
		WW_reviewoption = false;
		WW_barlayoutsize = 8;
		WW_barlayout.splice(0,WW_barlayout.length,0,1,7,8,2,4,5,6);
	}
	else	{
		WW_barlayoutsize = 7;
		WW_barlayout.splice(0,WW_barlayout.length,0,1,2,3,4,5,6);
	}
	if( WW_operatingmode == 3 )	{ // Game Case
		WW_resizeoption = "no,scrollbars=yes"
		if( WW_tangostatus  == 0 )	{ // Master
			WW_statusmode = 1;
			WW_barlayoutsize = 7;
			WW_barlayout.splice(0,WW_barlayout.length,0,1,2,3,4,5,6);
			WW_tangogamedealer = true;
		}
		else	{
			WW_barlayoutsize = 6;
			WW_barlayout.splice(0,WW_barlayout.length,0,1,2,4,5,6);
			WW_tangogamedealer = false;
		}
	}
		
	WW_buttonspec.message[3]= WW_statusmessage[WW_statusmode];
	WW_buttonspec.imageurl[3]= WW_statusfilename[WW_statusmode] + '.gif';
	WW_buttonspec.message[1]= WW_reviewmessage[WW_reviewmode];
	WW_buttonspec.imageurl[1] = WW_reviewfilename[WW_reviewmode] + '.gif';
	WW_setupbuttonbar(WW_buttonspec);
	WW_setupbuttonbar(WW_buttonclone);
	return true;

}	// End WW_setupmasterstuff()

// ******************** Start Section with input processing 

function WW_Tangostoreevent(receivedevent)	{ // Check and Store Event
//Event either comes from Tango or from archived events if WW_geteventmode = 2

	WW_settempjavaconsole(receivedevent.type + ' * ' + WW_numallevents + ' * ' + WW_numeventsdone + ' ' + WW_keeplastlocationevent);
	WW_requestupdate =0; // Event received!
	if(WW_isdefined(receivedevent.error))	{
		WW_javaprintevent(receivedevent);
		return true; }
	if(receivedevent.reject)
		return true;
	if( WW_isundefined(receivedevent.type))
		return true;
	if(WW_isundefined(receivedevent.sourceflag))
		return true; // reject events without a sourceflag
	if(WW_isdefined(receivedevent.adminmaster)&&WW_isdefined(receivedevent.sourcename))
		WW_addnewperson(receivedevent.sourcename,0,2);
	if(WW_isdefined(receivedevent.netmaster)&&WW_isdefined(receivedevent.sourcename))
		WW_addnewperson(receivedevent.sourcename,0,1);
	receivedevent.processed = 0;
	outputurltype = receivedevent.type;
	var eventindicator = -1;	// Indicator of event type
	if( (outputurltype.indexOf('form') >= 0) || (outputurltype.indexOf('link') >= 0)||(outputurltype.indexOf('scroll') >= 0) ||(outputurltype.indexOf('parameter') >= 0)||(outputurltype.indexOf('bookmark') >= 0))
		eventindicator=2;	// Update Events
	if( (outputurltype == 'pointerdefn')||(outputurltype == 'card')  )
		eventindicator =3;
	if( (outputurltype.indexOf('simplepage') >= 0) || (outputurltype.indexOf('windowsize') >= 0) )
		eventindicator=1;
	if( outputurltype == 'heart' )
		eventindicator =0;
	if(WW_isundefined(receivedevent.infotype))
		receivedevent.infotype = eventindicator;
	eventindicator = receivedevent.infotype;
	if( WW_nothingdone && ((eventindicator == 0) || (eventindicator == 1) || (eventindicator == 6) ) )	{
		WW_badloadlimit = 100;
		WW_notsobadloadlimit = 10;
		WW_waitforformtoact = 30;
		WW_numeventsdone = WW_numallevents;
		WW_nothingdone = false; }
	WW_sendaddcoloredhand(Math.max(0,eventindicator));

	if( eventindicator==7 )	{ // Timing Events Processed Locally and not in Event Loop
		receivedevent.minorevent = WW_numallevents+1;
		WW_eventrecord[WW_numallevents] = WW_cloneevent(receivedevent);
		++WW_numallevents;
		WW_readprobe(receivedevent);
		return true;
	}
	
	if( outputurltype == 'pointerdefn' )	{	// Process Pointer events
		if( WW_keeplastpointerevent > 0 )	{ // See if Identical to Before
			if( WW_compareevents(receivedevent,WW_eventrecord[WW_keeplastpointerevent-1]) )	{
				WW_eventrecord[WW_keeplastpointerevent-1].processed = 0;
				if( WW_numpointereventsdone >= WW_keeplastpointerevent )
					WW_numpointereventsdone = WW_keeplastpointerevent-1;
				return true;
			}
		}	// End test on previous events
		WW_keeplastpointerevent = WW_numallevents+1;
	}	// End processing of pointer events

	if( outputurltype == 'setparameter' )	{	// Process Parameter Events
		if( WW_keeplastparameterevent > 0 )	{ // See if Identical to Before
			if( WW_compareevents(receivedevent,WW_eventrecord[WW_keeplastparameterevent-1]) )
				return true;
		}	// End test on previous events
		WW_keeplastparameterevent = WW_numallevents+1;
	}	// End processing of parameter events

	if( outputurltype == 'bookmark' )	{	// Process System Bookmark Events
		if( WW_keeplastbookmarkevent > 0 )	{ // See if Identical to Before
			if( WW_compareevents(receivedevent,WW_eventrecord[WW_keeplastbookmarkevent-1]) )
				return true;
		}	// End test on previous events
		WW_keeplastbookmarkevent = WW_numallevents+1;
	}	// End processing of System bookmark events
	
	if( (outputurltype.indexOf('simplepage') >= 0) || (outputurltype.indexOf('windowsize') >= 0) )	{
		WW_doublecheckonthis = 0;
		WW_keeplastlocationevent = WW_numallevents+1;
	}	// Location Events

	if( outputurltype == 'heart' )	{
		if( WW_keeplastlocationevent > 0 )	{ // See if Identical to Before
			var evtouse = WW_eventrecord[WW_keeplastlocationevent-1];
			if( WW_compareevents(receivedevent,evtouse) )	{
				if(WW_isdefined(receivedevent.pagetitle))	{
					if( WW_isundefined(evtouse.pagetitle) || (evtouse.pagetitle != receivedevent.pagetitle) )	{
						evtouse.pagetitle = receivedevent.pagetitle;
						evtouse.message = 'From Heartbeat:' + receivedevent.pagetitle;
						var assmajev = evtouse.majorevent;
						if(WW_isdefined(assmajev) && (assmajev > 0 ))
							WW_majorevent[assmajev-1].label = evtouse.message;
					}
				}
				if( WW_numeventsdone <= WW_keeplastlocationevent )	{
					WW_doublecheckonthis = 0;
					evtouse.processed = 0; }
				else WW_doublecheckonthis = WW_keeplastlocationevent;
				return true;
			}
		}	// End test on previous events
		WW_keeplastlocationevent = WW_numallevents+1;
	}	// End processing of heart events

	receivedevent.minorevent = WW_numallevents+1;
	WW_eventrecord[WW_numallevents] = WW_cloneevent(receivedevent);
	++WW_numallevents;
	if( outputurltype.indexOf('form')>= 0 )	{	// Update Dialog Page if necessary
		if(WW_isitawindow(WW_dialogwindow))
			WW_dialogwindow.WW_writesharedformlayer();	
	}
	return true;

}	// End WW_Tangostoreevent(receivedevent)
	
// ***************** Accumulate Events and URL's(Major Events) for Master Only ************
function WW_accummajorinfo(docurl,doctitle)	{
	
	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return;
	WW_majorevent[WW_numberurl] = {};
	WW_majorevent[WW_numberurl].url = docurl +"";
	WW_majorevent[WW_numberurl].thumbnail = {};
	WW_majorevent[WW_numberurl].thumbnail.processed = -1;
	WW_majorevent[WW_numberurl].thumbnail.currenturl = '';
	WW_majorevent[WW_numberurl].label = doctitle;
	WW_majorevent[WW_numberurl].associatedevent = WW_numallevents;
	WW_updatefavorites(WW_majorevent[WW_numberurl].url);
	WW_majorevent[WW_numberurl].indicator = WW_numeventindicators;
	WW_registereventindicator(7,WW_numberurl,-2,WW_tangogrouplabel,WW_tangosequencenumber);
	++WW_numberurl;
	if(WW_numallevents>0)
		WW_eventrecord[WW_numallevents-1].majorevent = WW_numberurl;
	WW_numpointereventsdone = WW_numallevents;
	return;

}	// End WW_accummajorinfo(docurl,doctitle)

function WW_unpackthumbnail(packedversion)	{	// Unpack Thumbnail

	WW_testoneventtarget = false;
	var wwevent = new WW_basicevent();
	WW_getevent(packedversion,wwevent);
	WW_testoneventtarget = true;
	thumbnailobject = {};
	thumbnailobject.processed =1;
	thumbnailobject.currenturl = wwevent.currenturl;
	thumbnailobject.currentno = wwevent.currentno;
	thumbnailobject.numberstring = wwevent.numberstring;
	thumbnailobject.precursor = wwevent.precursor;
	thumbnailobject.postcursor = wwevent.postcursor;
	thumbnailobject.lengthofno = wwevent.lengthofno;
	return thumbnailobject;
	
}	// End	WW_unpackthumbnail(packedversion)

function WW_packthumbnail(thumbnailobject)	{	// Pack Thumbnail

	var wwevent = new WW_childevent('thumbnail');
	wwevent.currenturl = thumbnailobject.currenturl;
	wwevent.currentno = thumbnailobject.currentno;
	wwevent.numberstring = thumbnailobject.numberstring;
	wwevent.precursor = thumbnailobject.precursor;
	wwevent.postcursor = thumbnailobject.postcursor;
	wwevent.lengthofno = thumbnailobject.lengthofno;
	packedevent = WW_packevent(wwevent,'','');
	return packedevent;

}	// End WW_packthumbnail(thumbnailobject)

// Return URL to Thumbnail distance incr from Event Number eventm1+1
function WW_nextthumbnail(eventm1,incr)	{
	
	var thumbpt = WW_majorevent[eventm1].thumbnail;
	if( thumbpt.currenturl == '' )
		return '';
	var imagemaxno = WW_imageheuristicmaxno;
	var nextthumbnail = thumbpt.currentno + incr;
	if( nextthumbnail > imagemaxno )
		return '';
	var nexttextthumbnail = nextthumbnail.toString();
	var more = thumbpt.lengthofno - nexttextthumbnail.length;
	for(var m=0;m<more;m++)	{
		nexttextthumbnail = '0' + nexttextthumbnail; }
	nexttextthumbnail = thumbpt.precursor + nexttextthumbnail + thumbpt.postcursor;
	return nexttextthumbnail;

}	// End WW_nextthumbnail(eventm1,incr)

function WW_accumandsendevent(wwevent,target,message,heartflag)	{
// heartflag = 0 send but don't save
// heartflag >= 1 send and save
// heartflag = -1 only save
// heartflag = 3 is Selective Send

	if( WW_tangostatus == 0 )
		wwevent.adminmaster = true;
	if( WW_jssbusers[0].netmaster)
		wwevent.netmaster = true;
	if( heartflag >= 0 )	{
		var mess = WW_packevent(wwevent,target,message);
		if( heartflag == 0 )	{ // Heartflag=0 could be Selective
			if(WW_waitingparticipantlist.length <= 0)
				Tango_send(mess);
			else	{
				WW_setdebugline(' Selective Send ' + WW_waitingparticipantlist[0] + ' ' + WW_waitingparticipantlist.length);
				Tango_selectiveSend(WW_waitingparticipantlist,mess); }
		}
		if( heartflag == 3 )	{ // Heartflag=3 must be Selective
			if(WW_tempparticipantlist.length <= 0)
				Tango_send(mess);
			else	{
				WW_setdebugline(' Selective Send ' + WW_tempparticipantlist[0] + ' ' + WW_tempparticipantlist.length);
				Tango_selectiveSend(WW_tempparticipantlist,mess); }
		}
		else	{
			Tango_send(mess);
		}
	}
	else	{
		if( target != '' )
			wwevent.targetflag = target;
		if(WW_isundefined(wwevent.targetflag))
			wwevent.targetflag = WW_Eventanyname;
		if( message != '' )
			wwevent.message = message;
	}
	if( heartflag == 0)
		return;
	if(WW_isdefined(wwevent.type))	{
		if( (wwevent.type.indexOf('bookmark') >= 0)||(wwevent.type.indexOf('parameter') >= 0) || (wwevent.type.indexOf('form') >= 0) || (wwevent.type.indexOf('scroll') >= 0) || (wwevent.type.indexOf('link') >= 0))
			WW_sendaddcoloredhand(2);
		if(wwevent.type == 'pointerdefn' )
			WW_sendaddcoloredhand(3);
	}
	wwevent.majorevent = WW_numberurl;
	wwevent.minorevent = WW_numallevents+1;
	wwevent.processed = 1;
	WW_eventrecord[WW_numallevents] = WW_cloneevent(wwevent);
	++WW_numallevents;
	if( wwevent.type.indexOf('form')>= 0 )	{	// Update Dialog Page if necessary
		if(WW_isitawindow(WW_dialogwindow))
			WW_dialogwindow.WW_writesharedformlayer();	
	}

	if(WW_isdefined(wwevent.tangosequencenumber))	{
		if( WW_isundefined(wwevent.infotype) || (wwevent.infotype!=3))
			WW_labelstream[WW_tangosequencenumber].eventnumber = WW_numallevents;
	}
	return;

}	// End WW_accumandsendevent(wwevent,target,message,heartflag)

// ********************* end Section with input processing

// ********************* Start Section Containing Window Manipulation Routines
function WW_getstarted(x,y)	{

	WW_spawnedwindowwidth = parseInt(x);
	WW_spawnedwindowheight = parseInt(y);
	WW_targeturl = WW_firsturl;
	WW_startspawnedwindow();
	
}	// End WW_getstarted(x,y)

function WW_newgamelabel(player)	{

	if(player < 0 )	{ // Initialize
		WW_gamestream = ' Memory:' + WW_username;
		++WW_countgames;
		WW_gamegroup = WW_countgames;
		for(var m=0; m<=WW_playernames.length; m++)	{
			WW_gamemovearray[m]=0;
		}
		return -1;
	}
	++WW_gamemovearray[player];
	return WW_gamemovearray[player];

}	// End WW_newgamelabel(player)
		  
function WW_newtangolabel(streamflag,groupflag)	{ // Generate next Tango Group Label

	++WW_tangosequencenumber;
	var today = new Date();
	var currenttime = today.getTime();
	if( groupflag != '' )	{
		WW_tangogrouplabel = groupflag; }
	else	{
		WW_tangogrouplabel = currenttime; }
	WW_freewindow = WW_getspawnedframe('freewindow');
	var tickcount = -1;
	if(WW_freewindow != null)
		tickcount = WW_freewindow.WW_countcycles;
	WW_labelstream[WW_tangosequencenumber] = {};
	WW_labelstream[WW_tangosequencenumber].streamflag = streamflag;
	WW_labelstream[WW_tangosequencenumber].tickcount = tickcount;
	WW_labelstream[WW_tangosequencenumber].time = currenttime;
	WW_labelstream[WW_tangosequencenumber].grouplabel = WW_tangogrouplabel;
	WW_labelstream[WW_tangosequencenumber].eventnumber = -1;
	WW_labelstream[WW_tangosequencenumber].indicator = WW_numeventindicators;
	WW_registereventindicator(9,WW_tangosequencenumber,-2,WW_tangogrouplabel,WW_tangosequencenumber);
	return;
	
}	// End WW_newtangolabel()

// Event indicator * framenumber = -2 Unknown -1 parent 0... Child frame
// index is index into associated arrays
// type =1 WW_onunloadevent * type =2 WW_dynamictangoflagevent
// type =6 WW_wisdomregisterevent
// type =7 Generate new major event
// type =9 WW_labelstream
// type = 10 WW_completeddocumentsevent
function WW_registereventindicator(type,index,framenumber,grouplabel,seqno)	{

	var today = new Date();
	var currenttime = today.getTime();
	WW_freewindow = WW_getspawnedframe('freewindow');
	var tickcount = -1;
	if(WW_freewindow != null)
		tickcount = WW_freewindow.WW_countcycles;
	WW_eventindicators[WW_numeventindicators] = {};
	WW_eventindicators[WW_numeventindicators].time = currenttime;
	WW_eventindicators[WW_numeventindicators].tickcount = tickcount;
	WW_eventindicators[WW_numeventindicators].grouplabel = grouplabel;
	WW_eventindicators[WW_numeventindicators].sequencenumber = seqno;
	WW_eventindicators[WW_numeventindicators].framenumber = framenumber;
	WW_eventindicators[WW_numeventindicators].type = type;
	WW_eventindicators[WW_numeventindicators].index = index;
	++WW_numeventindicators;
	return true;

}	// End WW_registereventindicator(type,index,framenumber,grouplabel,seqno)

function WW_startspawnedwindow()	{
	if(WW_isitaspawnedwindow(WW_spawnedparent))  {
		import WW_spawnedparent.WW_spawnedparentclose;
		WW_spawnedparentclose();
	}
	WW_setupmasterstuff();
	WW_spawnedparentdone = false;
	WW_currentfullurl = '';
	WW_treasuredwindow = null;
	WW_freewindow = null;
	WW_expectedurl = '';
	WW_countspawnedtries = 0;
	WW_keeplastlocationevent = 0;
	++WW_Tango_number;
	WW_Tango_randomname = WW_Tango_randomname + WW_Tango_number;
	WW_spawnedparent = window.open(WW_totalpage,WW_Tango_randomname + 'SpawnedContentWindow',"screenX=50,screenY=50,innerWidth=" + WW_spawnedwindowwidth  + ",innerHeight=" + WW_spawnedwindowheight + ",toolbar=no,location=no,directories=no,status=yes,menubar=no,resizable=" + WW_resizeoption); 
	WW_neverdone =1;
	WW_nomoremessages =0;
	return true;
	
}	// End WW_startspawnedwindow

function WW_restartspawnedwindow()	{
	if( WW_isitaspawnedwindow(WW_spawnedparent)) 	{
		if( (WW_freewindow = WW_getspawnedframe('freewindow')) != null)
			if( (WW_isdefined(WW_freewindow.WW_tangoboss)) && (WW_getspawnedframe('WWsignedchild') != null))
				return false;
		if(WW_neverdone < 7)
			return true;
		if(WW_nomoremessages == 1)
			alert('Please Destroy window and restart from Dialog Window');
		++WW_nomoremessages;
		return true;
	}
	if(WW_neverdone < 7)
		return true;
	if(WW_nomoremessages == 1)
		alert('Please Restart Window form Dialog Window -- Data will appear in 30 Seconds');
	++WW_nomoremessages;
	return true;

}	// End WW_restartspawnedwindow()

function WW_button_Start(selectedurl)	{
	if(WW_isundefined(selectedurl))	{ // Incorrect Input
		WW_seterrorline(' Setting Undefined URL Ignored');
		return true;
	}
	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return true;
	if((WW_treasuredwindow = WW_getspawnedframe('WWsignedchild')) == null)
		return true;
	if( (WW_freewindow = WW_getspawnedframe('freewindow')) == null)
		return true;
	var localform = WW_getformhandle(0);
	if(localform == null )
		return true;
	localform.wwjssbstatus.value = "Welcome to Shared Event and page Browser:" + selectedurl;
	WW_treasuredwindow.location.href = selectedurl;
	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return true;
	import WW_spawnedparent.WW_spawnedalignfocus;
	WW_spawnedalignfocus(0);
	return true;

}	// End WW_button_Start -- set URL from field

function WW_button_Restart(backindex)	{
	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return true;
	if((WW_treasuredwindow = WW_getspawnedframe('WWsignedchild')) == null)
		return true;
	if( (WW_freewindow = WW_getspawnedframe('freewindow')) == null)
		return true;
	var localform = WW_getformhandle(0);
	if(localform == null )
		return true;
	var index = WW_numberurl-1-backindex;
	if( index < 0)
		index=0;
	var loadedurl = null;
	if( index > (WW_numberurl-1))	{
		loadedurl = WW_firsturl; }
	else	{
		loadedurl = WW_majorevent[index].url; }
	var label = 'Previous URL Set';
	if( backindex == 0 )
		label = 'Current URL Replayed';
	localform.wwjssbstatus.value = "Welcome to Shared Event and page Browser:" +label;
	WW_treasuredwindow.location.href = loadedurl;
	return true;

}	// End WW_button_ReStart -- set URL from Past

function WW_createhistory()	{
	
	WW_historyparent = window.open(WW_thisdocumentURLpath + 'WebWisdomArchive.html','HistoryParent');
	WW_alignfocuswindow(WW_historyparent,1);
	WW_historyparent.WW_madebytango = true;
	WW_updatebuttonbar();
	return;

}	// End WW_createhistory()

function WW_createurlclone()	{

	WW_historytarget = window.open(WW_globalurl,'HistoryTarget');
	WW_alignfocuswindow(WW_historytarget,2);
	WW_updatebuttonbar();
	return;

}	//	End WW_createurlclone()

// Process Sophisticated Clones -- WebWisdom Bookmarks
function WW_addpersonalbookmark(rawurl)	{ // Add Personal Bookmark

	if(WW_isundefined(rawurl))
		return;
	if( rawurl == '' )
		return;
	var use =0;
	if( WW_numpersonalbookmarks > 0 )	{
		use = WW_numpersonalbookmarks;
		for( var m=0; m < WW_numpersonalbookmarks; m++ )	{
			if(WW_personalbookmarkarray[m].active)	{
				if(WW_isitawindow(WW_personalbookmarkarray[m].handle))
					continue;
			}
			use = m;
			break;
		}
	}
	WW_personalbookmarkarray[use] = {};
	WW_personalbookmarkarray[use].currenturl = rawurl;
	WW_personalbookmarkarray[use].active = true;
	if( use >= WW_numpersonalbookmarks )
		WW_numpersonalbookmarks = use+1;
	var handle = window.open(rawurl,'PersonalBookmark' + use);
	handle.focus();
	WW_personalbookmarkarray[use].handle = handle;
	WW_selectedpersonalbookmark = use;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writeloadpagelayer(); }
	else	{
		WW_button_Dialog(1); }
	return true;

}	// End WW_addpersonalbookmark(rawurl)

function WW_focuspersonalbookmark(option)	{	// Focus or Reload selected personal bookmark

	if( WW_selectedpersonalbookmark < 0 )
		return true;
	if( WW_selectedpersonalbookmark >= WW_numpersonalbookmarks )
		return true;
	var local = WW_personalbookmarkarray[WW_selectedpersonalbookmark];
	if(!local.active)
		return true;
	if(!WW_isitawindow(local.handle))
		return true;
	if(option == 1 )
		local.handle.location.href = local.currenturl;
	local.handle.focus();
	return true;

}	// End WW_focuspersonalbookmark()

function WW_deletepersonalbookmark()	{	// Delete selected personal bookmark

	if( WW_selectedpersonalbookmark < 0 )
		return true;
	if( WW_selectedpersonalbookmark >= WW_numpersonalbookmarks )
		return true;
	var local = WW_personalbookmarkarray[WW_selectedpersonalbookmark];
	if(!local.active)
		return true;
	if(WW_isitawindow(local.handle))
		local.handle.close();
	local.active = false;
	local.currenturl = '(deleted)' + local.currenturl;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writeloadpagelayer(); }
	else	{
		WW_button_Dialog(1); }
	return true;

}	// End WW_deletepersonalbookmark()

function WW_addsystembookmark(rawurl,flag)	{ // Add System Bookmark

	if(WW_isundefined(rawurl))
		return;
	if( rawurl == '' )
		return;
	var use =0;
	if( flag < 0 )	{
		if( WW_numsystembookmarks > 0 )	{
			use = WW_numsystembookmarks;
			for( var m=0; m < WW_numsystembookmarks; m++ )	{
				if(WW_systembookmarkarray[m].active)	{
					if(WW_isitawindow(WW_systembookmarkarray[m].handle))
						continue;
				}
				use = m;
				break;
			}
		}
	}
	else	{
		use = WW_selectedsystembookmark; }
	WW_makesystembookmark(use,rawurl,WW_username,1);
	WW_sendsystembookmarks(1);
	return true;

}	// End WW_addsystembookmark(rawurl)

function WW_makesystembookmark(position,rawurl,username,option)	{	// Create New Location

	if( position < 0 )
		return;
	WW_systembookmarkarray[position] = {};
	WW_systembookmarkarray[position].currenturl = rawurl;
	WW_systembookmarkarray[position].active = true;
	WW_systembookmarkarray[position].username = username;
	if( position >= WW_numsystembookmarks )
		WW_numsystembookmarks = position+1;
	var handle = window.open(rawurl,'SystemBookmark' + position);
	handle.focus();
	WW_systembookmarkarray[position].handle = handle;
	WW_selectedsystembookmark = position;
	if(option==1)	{
		if(WW_isitawindow(WW_dialogwindow))
			WW_dialogwindow.WW_writeloadpagelayer();
	}
	return true;

}	// End WW_makesystembookmark(position,rawurl,username,option)

function WW_focussystembookmark(option)	{	// Focus or Reload selected system bookmark

	if( WW_selectedsystembookmark < 0 )
		return true;
	if( WW_selectedsystembookmark >= WW_numsystembookmarks )
		return true;
	var local = WW_systembookmarkarray[WW_selectedsystembookmark];
	if(!local.active)
		return true;
	if(!WW_isitawindow(local.handle))
		return true;
	if(option == 1 )
		local.handle.location.href = local.currenturl;
	local.handle.focus();
	return true;

}	// End WW_focussystembookmark()

function WW_deletesystembookmark(option)	{	// Delete selected system bookmark

	if( WW_selectedsystembookmark < 0 )
		return true;
	if( WW_selectedsystembookmark >= WW_numsystembookmarks )
		return true;
	var local = WW_systembookmarkarray[WW_selectedsystembookmark];
	if(!local.active)
		return true;
	if(WW_isitawindow(local.handle))
		local.handle.close();
	local.active = false;
	var teststring = local.currenturl;
	if( teststring.indexOf('(deleted)') < 0)
		local.currenturl = '(deleted)' + teststring;
	if(option == 1)	{
		if(WW_isitawindow(WW_dialogwindow))
			WW_dialogwindow.WW_writeloadpagelayer();
		WW_alignfocuswindow(WW_dialogwindow,3);
	}
	WW_sendsystembookmarks(1);
	return true;

}	// End WW_deletesystembookmark(option)

function WW_sendsystembookmarks(heartflag)	{	// Send System Bookmarks to Non Master

	if( WW_numsystembookmarks <= 0 )
		return true;
	if(heartflag>0)
		WW_newtangolabel(WW_localflag,WW_tangogrouplabel);
	var wwevent = new WW_generatedevent(WW_username,WW_localflag,WW_tangogrouplabel,WW_tangosequencenumber,'bookmark');
	var num = WW_numsystembookmarks;
	wwevent.arraysize = num;
	wwevent.selectedindex = WW_selectedsystembookmark;
	wwevent.arrayitself = new Array();
	for(var m=0; m <num;m++)	{
		wwevent.arrayitself[m] = {};
		wwevent.arrayitself[m].active = WW_systembookmarkarray[m].active;
		wwevent.arrayitself[m].username = WW_systembookmarkarray[m].username;
		wwevent.arrayitself[m].currenturl = WW_systembookmarkarray[m].currenturl;
	}
	WW_accumandsendevent(wwevent,WW_Eventanyname,' Send System Bookmarks',heartflag);
	return true;

}	// End WW_sendsystembookmarks()   

function WW_readsystembookmarks(receivedevent)	{ // Read System Bookmarks

	var num = receivedevent.arraysize;
	if(num <= 0 )
		return true;
	var old = WW_numsystembookmarks;
	if( num < old )	{ // Some Problem -- Delete Everything and Start Again
		for( var m =0; m< old; m++ )	{
			WW_selectedsystembookmark = m;
			WW_deletesystembookmark(0);
		}
		WW_systembookmarkarray = new Array();
		WW_numsystembookmarks = 0;
		WW_selectedsystembookmark = -1;
		old =0;
	}
	for( var m=0; m < num; m++ )	{
		var newactive = receivedevent.arrayitself[m].active;
		var newurl = receivedevent.arrayitself[m].currenturl;
		if( m < old )	{ // Update Old Entry
			if(!newactive)	{
				WW_systembookmarkarray[m].currenturl = newurl;
				WW_systembookmarkarray[m].username = receivedevent.arrayitself[m].username;
				WW_selectedsystembookmark = m;
				WW_deletesystembookmark(0);
				continue;
			}
			else	{
				WW_makesystembookmark(m,newurl,receivedevent.arrayitself[m].username,1);
			}
		}
		else	{	// New Entry
			if(!newactive)	{
				WW_systembookmarkarray[m] = {};
				WW_systembookmarkarray[m].currenturl = newurl;
				WW_systembookmarkarray[m].active = false;
				WW_systembookmarkarray[m].username = receivedevent.arrayitself[m].username;
				WW_systembookmarkarray[m].handle = null;
				continue;
			}
			WW_makesystembookmark(m,newurl,receivedevent.arrayitself[m].username,0);
		}
	}
	WW_selectedsystembookmark = receivedevent.selectedindex;
	WW_numsystembookmarks = num;
	WW_focussystembookmark(0);
	if(WW_isitawindow(WW_dialogwindow))
		WW_dialogwindow.WW_writeloadpagelayer();
	WW_alignfocuswindow(WW_dialogwindow,3);
	return true;
	
}	// End WW_readsystembookmarks(receivedevent)

function WW_setsystembookmarkuser()	{

	if( WW_selectedsystembookmark < 0 )
		return true;
	var actualname = WW_jssbusers[WW_selectedsystembookmarkuser].name;
	var oldname = WW_systembookmarkarray[WW_selectedsystembookmark].username;
	if(oldname == actualname)
		return true;
	WW_systembookmarkarray[WW_selectedsystembookmark].username = actualname;
	WW_sendsystembookmarks(1);
	if(WW_isitawindow(WW_dialogwindow))
		WW_dialogwindow.WW_writeloadpagelayer();
	WW_alignfocuswindow(WW_dialogwindow,3);
	return true;

}	// Set System Bookmark Name

function WW_settimelabel(eventnumberm1,localfirsttime)	{

	var answer = {};
	answer.here = '';
	answer.there = '';
	answer.sourcename = 'Unknown';
	if(localfirsttime < 0)
		return answer;
	if( eventnumberm1 >= WW_numallevents)
		return answer;
	wwevent = WW_eventrecord[eventnumberm1];
	if( WW_isdefined(wwevent.sourcename))	{
		answer.sourcename = wwevent.sourcename;
		if( wwevent.sourcename == WW_username )
			answer.sourcename = '';
		if(wwevent.sourceflag.indexOf('/replay:')>= 0 )
			answer.sourcename += '/Replay';
		if( wwevent.sourcename == WW_username )	{
			if( WW_isdefined(wwevent.sourcetime) )
				answer.here = WW_toseconds(wwevent.sourcetime - localfirsttime);
			if( WW_isdefined(wwevent.targettime) )
				answer.there = WW_toseconds(wwevent.targettime - localfirsttime);
		}
		else	{
			if( WW_isdefined(wwevent.sourcetime) )
				answer.there = WW_toseconds(wwevent.sourcetime - localfirsttime);
			if( WW_isdefined(wwevent.targettime) )
				answer.here = WW_toseconds(wwevent.targettime - localfirsttime);
		}
		return answer;
	}	
	if( WW_isdefined(wwevent.sourcetime) )	{
		answer.there = WW_toseconds(wwevent.sourcetime - localfirsttime);
	}
	if( WW_isdefined(wwevent.targettime) )	{
		answer.here = WW_toseconds(wwevent,localfirsttime); }
	return answer;

}	// End WW_settimelabel(eventnumberm1)

function WW_seteventprintline(eventnumberm1)   {

	wwevent = WW_eventrecord[eventnumberm1];
	if( WW_isundefined(wwevent) )
		return '';
	var answer ='';
	if( WW_isdefined(wwevent.type) )
		answer = wwevent.type + ':';
	if( WW_isdefined(wwevent.message))
		answer += ' ' + wwevent.message;
	return ('<a href="javascript:void(0)" onclick="bigboss.WW_processevent(event.pageX,event.pageY,' + eventnumberm1 + ')" >' + answer + '</a>');

}	// WW_seteventprintline(eventnumberm1)

function WW_processevent(xval,yval,eventnumberm1)	{ // Called from History Page when you click on an event

	WW_eventparmpage = WW_getlayer("eventuse",WW_historyparent);
	if(WW_isdefined(WW_eventparmpage))	{ // WW_eventparmpage is layer for event options
		var layertext = "<b>Event: " + (eventnumberm1+1).toString() + " Choose one of the Actions</b><form name='eventactions' ><input type=button value='Delete Layer!' onclick='bigboss.WW_hideeventparmpage()'>";
		if(WW_isdefined(WW_historyparent.WW_madebytango))	{
			layertext += "<input type=button value='Display Event' onclick='bigboss.WW_processevent0(" + eventnumberm1 + ")' >";
			var finalreplayevent = -1;
			if( WW_lasteventtoreplay > 0 )
				finalreplayevent = WW_lasteventtoreplay;
			if( finalreplayevent <= eventnumberm1 )
				finalreplayevent = WW_numallevents;
			layertext += "<br><input type=button value='Start Full Replay Here' onclick='bigboss.WW_processevent1(" + xval + "," + yval + "," + eventnumberm1 + ")' >";
			layertext += " Current Last event # " + finalreplayevent.toString();
			layertext += "<br><input type=button value='Stop Replay Here' onclick='bigboss.WW_processevent4(" + eventnumberm1 + ")' >";
			var evtype = WW_eventrecord[eventnumberm1].type;
			if(WW_isundefined(evtype))
				evtype = ' Undefined';
			layertext += "<br><input type=button value='Load Event' onclick='bigboss.WW_processevent3(" + eventnumberm1 + ")' >";
			layertext += ' Event type ' + evtype.toString();
			layertext += "<br><input type=button value='Load Associated Page' onclick='bigboss.WW_processevent2(" + eventnumberm1 + ")' >";
			if(evtype.indexOf('form') >= 0 )	{
				layertext += "<br><input type=button value='Load Form Data' onclick='bigboss.WW_processevent5(" + eventnumberm1 + ")' >";
			}
			layertext += "</form>"; }
		else	{
			layertext += "</form><br>Data not Imported. <br>Please do this from History Tab in Dialog Window"; }
		WW_changelayer(WW_eventparmpage,layertext,"pink",75,true);
		var wd = WW_getlayerwidth(WW_eventparmpage);
		var hgt = WW_getlayerheight(WW_eventparmpage);
		var XY = WW_positionmessage(xval,yval,20,20,wd,hgt,WW_historyparent);
		WW_layershiftto(WW_eventparmpage,XY.left,XY.top);
	}
	return true;

}	// End WW_processevent(eventnumberm1)

//	Start Set of Handlers called from Event Parameter Page
function WW_hideeventparmpage()	{	// Hide Event Parameter Page

	if(WW_isundefined(WW_eventparmpage))
		return true;
	WW_layerhide(WW_eventparmpage);
	WW_eventparmpage = null;

}	// End WW_hideeventparmpage()

// Simplest action is print out an event
function WW_processevent0(eventnumberm1)	{

	WW_eventtoprint = WW_eventrecord[eventnumberm1]; // set event to print out
	WW_eventpropwindow = window.open(WW_thisdocumentURLpath + 'WebWisdomEvent.html','SingleEventPrint');
	WW_eventpropwindow.focus(); // create and focus event property window
	return true;

}	// End WW_processevent0(eventnumberm1)

// Layer for Minor Event
function WW_processevent1(xval,yval,eventnumberm1)	{ //	Start a complete replay

	WW_hideeventparmpage();
	WW_eventparmpage = WW_getlayer("eventuse",WW_historyparent);
	if(WW_isdefined(WW_eventparmpage))	{ // WW_eventparmpage is layer for event options
		var layertext = "<b>Event: " + (eventnumberm1+1).toString() + " Choose Time Intervals and Click OK</b>";
		layertext += "<form name='eventtimes' ><input type=button value='OK' onclick='bigboss.WW_processevent6(" + eventnumberm1 + ",eventtimes.minortime.value,eventtimes.majortime.value)' > <input type=button value='Cancel' onclick='bigboss.WW_hideeventparmpage()'>";
		layertext += "<br>Minor Event Time Interval <input type=text size=5 value='' name='minortime'>";
		layertext += "<br>Major Event Time Interval <input type=text size=5 value='' name='majortime'>";
		if(!WW_replaylocally)	{
			layertext += "<br><input type=button value='Local Replay' onclick='bigboss.WW_processevent7(" + xval + "," + yval + "," + eventnumberm1 + ",true)'>"; }
		else	{
			layertext += "<br><input type=button value='Cancel Local Replay' onclick='bigboss.WW_processevent7(" + xval + "," + yval + "," + eventnumberm1 + ",false)'>"; }
		layertext += "</form>";
		WW_changelayer(WW_eventparmpage,layertext,"yellow",75,true);
		var wd = WW_getlayerwidth(WW_eventparmpage);
		var hgt = WW_getlayerheight(WW_eventparmpage);
		var XY = WW_positionmessage(xval,yval,20,20,wd,hgt,WW_historyparent);
		WW_layershiftto(WW_eventparmpage,XY.left,XY.top);
	}
	return true;

}	// End 	WW_processevent1(xval,yval,eventnumberm1)

// Layer for Major Event in History Page
function WW_processmajoreventclick(xval,yval,majoreventnumberm1)	{ 

	WW_hideeventparmpage();
	WW_eventparmpage = WW_getlayer("eventuse",WW_historyparent);
	if(WW_isdefined(WW_eventparmpage))	{ // WW_eventparmpage is layer for event options
		var localpt = WW_majorevent[majoreventnumberm1];
		var extractedthumb = 'Not Found';
		if( WW_isdefined(localpt.thumbnail.currenturl))
			extractedthumb = localpt.thumbnail.currenturl;
		var layertext = "<form name='eventparmactions' ><input type=button value='Delete Layer!' onclick='bigboss.WW_hideeventparmpage()'></form>";
		layertext += "<b>Major Event No " + (majoreventnumberm1+1).toString() + "</b> Associated Minor Event No " + localpt.associatedevent;
		layertext += "<br>Url: " + localpt.url + "<br>Label: " + localpt.label + "<br>Thumbnail: " + extractedthumb;
		WW_changelayer(WW_eventparmpage,layertext,"pink",75,true);
		var wd = WW_getlayerwidth(WW_eventparmpage);
		var hgt = WW_getlayerheight(WW_eventparmpage);
		var XY = WW_positionmessage(xval,yval,20,20,wd,hgt,WW_historyparent);
		WW_layershiftto(WW_eventparmpage,XY.left,XY.top);
	}
	return true;

}	// End 	WW_processmajoreventclick(xval,yval,majoreventnumber)

function WW_processevent6(eventnumberm1,t1,t2)	{ // Call to initiate replay after parameters known

	if( t1 != '')
		WW_minortimeinterval = parseInt(t1);
	if( t2 != '')
		WW_majortimeinterval = parseInt(t2);
	WW_hideeventparmpage();
	WW_startreplay(eventnumberm1);
	WW_replaystream = false;
	return true;

}	// End WW_processevent6(eventnumberm1)

function WW_processevent7(xval,yval,eventnumberm1,localreplay)	{ // Set Local Replay

	WW_replaylocally = localreplay;
	if(WW_tangostatus == 1 )
		WW_replaylocally = true;
	var localform = WW_getformhandle(3);
	if(localform==null)
		return;
	localform.replaylocallychange.checked = WW_replaylocally;
	WW_processevent1(xval,yval,eventnumberm1);
	return true;

}	// End WW_processevent7(localreplay)
		
function WW_processevent2(eventnumberm1)	{ // Load page associated with an event

	WW_reloadapage(eventnumberm1);
	return true;

}	// End WW_processevent2(eventnumberm1)

function WW_processevent3(eventnumberm1)	{ // Load consequence of an event

	WW_reloadanevent(eventnumberm1);
	return true;

}	// End WW_processevent3(eventnumberm1)

function WW_processevent4(eventnumberm1)	{ // Set last event to stop reply ( can be done dynamically)

	WW_lasteventtoreplay = eventnumberm1+1;
	WW_eventparmpage = WW_getlayer("eventuse",WW_historyparent);
	if(WW_isdefined(WW_eventparmpage))	{ // WW_eventparmpage is layer for event options
		WW_processevent(WW_getlayerleft(WW_eventparmpage),WW_getlayertop(WW_eventparmpage),eventnumberm1);
	}
	return true;

}	// End WW_processevent4(eventnumberm1)

function WW_processevent5(eventnumberm1)	{ // Reset a Form or part of a form from a dump

	var evtype = WW_eventrecord[eventnumberm1].type;
	if(WW_isdefined(evtype))	{
		if(evtype.indexOf('form') >= 0 )	{
			WW_resetforms(eventnumberm1);
		}
	}
		return true;

}	// End WW_processevent5(eventnumberm1)

//	End Set of Handlers called from Event Parameter Page

// Decide if to include event in hisory list
function WW_discardevent(eventm1)	{

	var evtype = WW_eventrecord[eventm1].type;
	if(WW_isundefined(evtype))
		return false;
	if(evtype == 'pointerdefn')
		return !WW_listpointerstuff;
	if( evtype.indexOf('form') >= 0 )
		return !WW_listformstuff;
	return false;

}	// End WW_discardevent(eventm1)

function WW_toseconds(valinmillisecs)	{	// Convert milliseconds to seconds

	var absval = Math.abs(valinmillisecs);
	if( absval == 0 )
		return '0&nbsp;&nbsp;&nbsp;&nbsp;';
	var stringval = absval.toString();
	var lengthval = stringval.length;
	if( absval >= 1000)
		stringval = stringval.slice(0,lengthval-3) + '.' + stringval.slice(lengthval-3);
	else	{
		if( absval >= 100 )
			stringval = '0.' + stringval;
		else	{
			if( absval >= 10 )
				stringval = '0.0' + stringval;
			else
				stringval = '0.00' + stringval;
		}
	}
	if( valinmillisecs <0 )
		stringval = '-' + stringval;
	return stringval;

}	// End WW_toseconds(valinmillisecs)

/* Button to Create Dialog Box	*/
function WW_button_Dialog(option)	{

	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.close(); }
	var dialogwindowwidth = (WW_numdialogtablayers-1)*WW_dialogtabwidth;
	var useypos = WW_userwindowypos;
	var xpos = screen.width;
	if( option == 0 )	{
		WW_dialogwindow = window.open(WW_thisdocumentURLpath  + "dialogwindow.html",WW_Tango_randomname + 'DialogWindow','toolbar=no,location=no,menubar=no,resizable=yes,directories=no,status=no,width=' + dialogwindowwidth + ',height=550');
	}
	else	{
		WW_dialogwindow = window.open(WW_thisdocumentURLpath  + "dialogwindow.html",WW_Tango_randomname + 'DialogWindow','screenX=' + (xpos-dialogwindowwidth-10) + ',screenY=' + useypos + ',toolbar=no,location=no,menubar=no,resizable=yes,directories=no,status=no,width=' + dialogwindowwidth + ',height=550');
	}
	WW_updatebuttonbar();
	return true;

}	// End	WW_button_Dialog(option)

/* Button to Create Review Window */
function WW_button_Review(makeorbreak)	{
	
	if( WW_operatingmode == 3 )
		return true;
	if( makeorbreak == 0 )	{ // Destroy window if allowed
		if(WW_keepreviewwindow)
			return true;
		if(WW_isitawindow(WW_reviewwindow))
			WW_reviewwindow.close();
		return true;
	}	
		
	if(WW_isitawindow(WW_reviewwindow))	{
		WW_reviewwindow.WW_remakereviewwindow();
		return true; }
	var WW_snoopimageheight = 50. + WW_snoopfactor*WW_snoopimagewidth;
	WW_reviewwindow = window.open(WW_thisdocumentURLpath + "reviewwindow.html",WW_Tango_randomname + 'ReviewWindow','toolbar=no,location=no,menubar=no,resizable=yes,directories=no,status=no,width=' + WW_snoopimagewidth + ',height=' + WW_snoopimageheight);
	WW_alignfocuswindow(WW_reviewwindow,4);
	WW_updatebuttonbar();
	return true;
	
}	// WW_button_Review(makeorbreak)

function WW_processconsoleclick(xval,yval,localtype,index)	{ // Called from Console Page

	WW_consoleparmpage = WW_getlayer("consoleparm",WW_consolewindow);
	if(WW_isdefined(WW_consoleparmpage))	{ // WW_consoleparmpage is layer for event options
		var layertext = "<b>Index: " + index + " Further Details</b><form name='consoleparmactions' ><input type=button value='Delete Layer!' onclick='bigboss.WW_hideconsoleparmpage()'></form>";
		if(WW_isdefined(WW_consolewindow.WW_madebytango))	{
			if( localtype == 1 )	{ // Onunload
				layertext += "Unload Signature " + index + " set by WebWisdom<br> and Detected. Signifies Exact End of Page"; }
			if( localtype == 2 )	{ // Dynamic Tango
				layertext += "Dynamic Tango Signature " + index + " set by WebWisdom<br>Signifies End of Page with Clock Tick Granularity"; }
			if( localtype == 6 )	{ // Wisdom Register
				layertext += "Self Registering Page " + index + "<br>Registered Type " + WW_wisdomregisterevent[index].pagetype + " Label " + WW_wisdomregisterevent[index].pagelabel;
				if(WW_isitawindow(WW_wisdomregisterevent[index].pointerframe))
					layertext += "<br>Pointer Defined on Page";	
			}
			if( localtype == 7 )	{ // Major Event
				var localpt = WW_majorevent[index];
				var extractedthumb = 'Not Found';
				if( WW_isdefined(localpt.thumbnail.currenturl))
					extractedthumb = localpt.thumbnail.currenturl;
				layertext += "Major Event No " + (index+1).toString() + " Associated Minor Event No " + localpt.associatedevent;
				layertext += "<br>Url: " + localpt.url + "<br>Label: " + localpt.label + "<br>Thumbnail: " + extractedthumb;
			}
			if( localtype == 9 )	{ // Tango Sequence Set
				var localpt = WW_labelstream[index];
				layertext += "Tango Sequence Index " + index;
				layertext += "Stream: " + localpt.streamflag + "<br>Group: " + localpt.grouplabel;
				layertext += "Clock Tick: " + localpt.tickcount + " Time: " + localpt.time;
				layertext += "<br>Minor Event Number: " + localpt.eventnumber;
			}
			if( localtype == 10 )	{ // Document Completions
				layertext += "Document More or Less Fully Loaded " + index + " Num Elements " + WW_completeddocumentsevent[index].numelements + "<br>Signifies Real Loading of Page with Clock Tick Granularity";
			}
		}
		else	{
			layertext += "<br>Page defective: Please remake"; }
		WW_changelayer(WW_consoleparmpage,layertext,"pink",75,true);
		var wd = WW_getlayerwidth(WW_consoleparmpage);
		var hgt = WW_getlayerheight(WW_consoleparmpage);
		var XY = WW_positionmessage(xval,yval,20,20,wd,hgt,WW_consolewindow);
		WW_layershiftto(WW_consoleparmpage,XY.left,XY.top);
	}
	return true;

}	// End WW_processconsoleclick(xval,yval,localtype,index)

//	Handler called from Console Parameter Page
function WW_hideconsoleparmpage()	{	// Hide Console Parameter Page

	if(WW_isundefined(WW_consoleparmpage))
		return true;
	WW_layerhide(WW_consoleparmpage);
	WW_consoleparmpage = null;

}	// End WW_hideconsoleparmpage()


/* Button to Create Console Window */
function WW_button_Console()	{

	if(WW_isitawindow(WW_consolewindow))
		WW_consolewindow.close();
	WW_consolewindow = window.open(WW_thisdocumentURLpath + "consolewindow.html",WW_Tango_randomname + 'ConsoleWindow','toolbar=no,location=no,menubar=yes,resizable=yes,scrollbars=yes,directories=no');
	WW_consolewindow.focus();
	WW_updatebuttonbar();
	return true;
	
}	// End WW_button_Console()

function WW_consolehandler()	{ // Called from onload handler of Console

	if( WW_consolehandlerparm < 0 )
		return true;
	if( WW_consolehandlerparm >= WW_numconfigs )
		return true;
	WW_controlconfiglayer1(WW_consolehandlerparm);
	return true;

}	// End WW_consolehandler()

/* Button to Create Status Window */
function WW_button_Status()	{

	if(WW_isitawindow(WW_statuswindow))
		WW_statuswindow.close();
	WW_statuswindow = window.open(WW_thisdocumentURLpath + "statuswindow.html",WW_Tango_randomname + 'StatusWindow','toolbar=no,location=no,menubar=no,resizable=yes,scrollbars=yes,directories=no,status=no,width=600,height=500');
	WW_statuswindow.focus();
	WW_updatebuttonbar();
	return true;
	
}	// End WW_button_Status()

function WW_getformhandle(sitenumber)	{
// return null if requested form does not exist, Otherwise return object pointer to form
// WW_numberofsites is number of forms and argument sitenumber lies between 0 and WW_numberofsites-1
// WW_sourcewindow[sitenumber] is window where form is
// WW_sourceform[sitenumber] is local object pointer in WW_sourcewindow[sitenumber] pointing to form

	if(sitenumber >= WW_numberofsites)
		return null;
	eval('var windowsite = ' + WW_sourcewindow[sitenumber]);
	if(!WW_isitawindow(windowsite))
		return null;
	eval('var formsite = windowsite.' + WW_sourceform[sitenumber]);
	if(WW_isundefined(formsite))
		return null;
	return formsite;

}	// End	WW_getformhandle(sitenumber)


// ******************* Start Utility Routines ********************************************

// This assumes you have loaded a legal history parent page using "save as"
function WW_connecttohistory()	{ // Establish Link to History Parent

	if(WW_isitawindow(WW_historyparent))
		WW_historyparent.bigboss = self;
	return;

}	// End WW_connecttohistory()

function WW_startreplay(eventm1)	{	// Control Replay of Event List
// WW_replaylocally is true implies replay() is accepted on local machine

	WW_geteventmode = 2;
	WW_finalreplayevent = -1;
	WW_previousreplayevent = eventm1;
	WW_lasttowaitfor = 0;
	WW_lastwaitedevent = -1;
	if( WW_lasteventtoreplay > 0 )
		WW_finalreplayevent = WW_lasteventtoreplay;
	if( WW_finalreplayevent <= WW_previousreplayevent )
		WW_finalreplayevent = WW_numallevents;
	WW_setupinternaleventaccess();
	WW_startbarmessage('Replay Started -- Go to skip events button in Control tab to Terminate',30);
	return;

}	//	End WW_startreplay(eventm1)

function WW_setupinternaleventaccess()	{

	var today = new Date();
	WW_realtime = today.getTime();
	WW_virtualtime = WW_geteventtime(WW_previousreplayevent+1);
	WW_unsetlastpointers();
	WW_replaynumber++; // Increase Count of Replays
	return;
	
}	// End WW_setupinternaleventaccess()

// Sometimes follow with code to zero out WW_numpointereventsdone WW_numeventsdone
function WW_unsetlastpointers()	{	// Unset Pointers into Event Queue
	
	WW_numpointereventsdone = WW_numallevents;
	WW_numeventsdone = WW_numallevents;
	WW_keeplastpointerevent = 0; // Unset Last Pointer Event
	WW_keeplastlocationevent = 0; // Unset Last Location Event
	WW_keeplastparameterevent = 0; // Unset Last Parameter Event
	WW_keeplastbookmarkevent = 0; // Unset Last Bookmark Event
	WW_resetpointerto = -1;
	
}	// End WW_unsetlastpointers()

function WW_Addnextevent()	{ // Add next event to local list

	if( WW_previousreplayevent >= WW_finalreplayevent)	{
		if( WW_replaylocally && ((WW_numeventsdone < WW_numallevents) || (WW_numpointereventsdone < WW_numallevents)) )
			return;
		WW_geteventmode = WW_tangostatus;
		WW_realtime = -1;
		WW_virtualtime = -1;
		WW_numpointereventsdone = WW_numallevents;
		WW_numeventsdone = WW_numallevents;
		WW_removebarmessage();
		return;
	}
	if( WW_eventrecord[WW_previousreplayevent].infotype == 7 )	{
		++WW_previousreplayevent;
		return;
	}
	var mintimedelta = WW_minortimeinterval;
	if( (WW_previousreplayevent>=1) && (WW_eventrecord[WW_previousreplayevent].majorevent != WW_eventrecord[WW_previousreplayevent-1].majorevent) )
		mintimedelta = WW_majortimeinterval;
	var virtualtimedelta = WW_geteventtime(WW_previousreplayevent+1);
	var today = new Date();
	var currenttime = today.getTime();
	var currenttimedelta = currenttime - WW_realtime;
	if( (virtualtimedelta >= 0) && (WW_virtualtime >= 0) )	{
		virtualtimedelta = virtualtimedelta - WW_virtualtime;
		if( mintimedelta > 0 )
			virtualtimedelta = Math.min(mintimedelta,virtualtimedelta);
		if( virtualtimedelta > currenttimedelta )	{
			var towaitfor = virtualtimedelta - currenttimedelta;
			if( (WW_lastwaitedevent != WW_previousreplayevent) || (towaitfor < WW_lasttowaitfor -5000) )	{
				WW_startbarmessage('Doing Event ' + WW_previousreplayevent + ' Time to go ' + towaitfor,100);
				WW_lastwaitedevent = WW_previousreplayevent;
				WW_lasttowaitfor = towaitfor;
			}
			return;
		}
	}
	if( currenttimedelta < WW_minimumtimeinterval)
		return;
	WW_virtualtime = WW_geteventtime(WW_previousreplayevent+1);
	WW_realtime = currenttime;
	var wwevent = WW_cloneevent(WW_eventrecord[WW_previousreplayevent]);
	++WW_previousreplayevent;
	wwevent.processed = 0;
	if(WW_isundefined(wwevent.originalsourcetime) )	{
		if(WW_isundefined(wwevent.sourcetime) )	{
			wwevent.originalsourcetime = currenttime; }
		else	{
			wwevent.originalsourcetime = wwevent.sourcetime; }
	}
	wwevent.sourcetime = currenttime;
	wwevent.sourceflag = WW_localflag + '/replay:' +WW_replaynumber;
	WW_newtangolabel(wwevent.sourceflag,wwevent.tangogrouplabel);
	wwevent.tangosequencenumber = WW_tangosequencenumber;
	if( WW_isundefined(wwevent.originaltargettime) )	{
		if( WW_isdefined(wwevent.targettime) )
			wwevent.originaltargettime = wwevent.targettime;
	}
	message = 'Replay of ';
	if( WW_isdefined(wwevent.message) )	{
		message += wwevent.message; }
	else	{
		message += 'event ' + WW_previousreplayevent; }
	var mess = WW_packevent(wwevent,WW_Eventnonmastername,message);
	if(WW_tangostatus == 0 )
		Tango_send(mess);
	if( WW_replaylocally )	{
		wwevent.targetname = WW_username;
		WW_testoneventtarget = false; // Allow all events to be unpacked
		WW_setjavaconsole(WW_previousreplayevent+" c:"+currenttimedelta +" v:"+virtualtimedelta);
		WW_Tangostoreevent(wwevent);
		WW_testoneventtarget = true; }
	return;

}	// End	function WW_Addnextevent()

function WW_geteventtime(eventno)	{
	
	var wwevent = WW_eventrecord[eventno-1];
	if( WW_isundefined(wwevent))	{
		return -1; }
	if( WW_isdefined(wwevent.originalsourcetime))	{
		return wwevent.originalsourcetime; }
	if( WW_isdefined(wwevent.sourcetime))	{
		return wwevent.sourcetime; }
	return -1;
	
}	// End WW_geteventtime(eventno)

function WW_reloadapage(eventm1)	{	// Just reload Single Page from List
// Argument is (Minor) Event Number minus 1 -- Replay Associated Major event
	
	WW_numeventsdone = WW_numallevents;
	WW_numpointereventsdone = WW_numallevents;
	var wwevent = WW_eventrecord[eventm1];
	if(WW_isundefined(wwevent))
		return;
	if(WW_isundefined(wwevent.majorevent))
		return;
	var wantedurl = WW_majorevent[wwevent.majorevent-1].url;
	WW_button_Start(wantedurl);
	return;

}	// End WW_reloadapage(eventm1)

function WW_reloadanevent(eventm1)	{	// Just reload Single Event from List
// Argument is Event Number minus 1 -- Replay This minor event
// WW_replaylocally is true implies replay is accepted on local machine
// A single pointer event on master is not replayed

	var wwevent = WW_eventrecord[eventm1];
	if(WW_isundefined(wwevent))
		return;
	WW_geteventmode = 2;
	WW_finalreplayevent = eventm1+1;
	WW_previousreplayevent = eventm1;
	WW_setupinternaleventaccess();
	return;

}	// End WW_reloadanevent(eventm1)

function WW_cleanseevents()	{ // Cleanse Event Queue at User Request

	WW_unsetlastpointers();
	WW_processingerrorflag = 0;
	WW_doublecheckonthis = 0;
	if( WW_geteventmode == 2 )	{ // Replay Mode
		WW_geteventmode = WW_tangostatus;
		WW_realtime = -1;
		WW_virtualtime = -1;
		WW_finalreplayevent = WW_previousreplayevent;
	}
	WW_removebarmessage();
	WW_updatebuttonbar();
	return;
	
}	// End WW_cleanseevents()

function WW_stopreplay()	{	// Stop Replay here

	WW_geteventmode = WW_tangostatus;
	WW_finalreplayevent = WW_previousreplayevent;
	return;
	
}	// End WW_stopreplay()

function WW_createconfig(no,username)	{

	this.no = no;
	this.systemname = 'WWJSSBConfig' + no;
	this.username = username;
	this.preferred = false;
	this.currenturl = '';
	this.masteroption = 2; // 0 Master, 1 Non Master, 2 both 
	this.configtype ='WW1,WW2,WW3';
	this.packedww1 = '';
	this.packedww2 = '';
	this.packedww3 = '';
	this.packedfav = '';
	
}	// End WW_createconfig(no)

function WW_setconfig(no,username)	{

	WW_configarray[no] = new WW_createconfig(no,username);
	WW_configarray[no].masteroption = WW_tangostatus;
	WW_configarray[no].currenturl = WW_userinput;
	var wwevent = WW_eventsetWW1();
	WW_configarray[no].packedww1 = WW_packevent(wwevent,WW_Eventlocalname,'WWParmSet1');
	wwevent = WW_eventsetWW2();
	WW_configarray[no].packedww2 = WW_packevent(wwevent,WW_Eventlocalname,'WWParmSet2');
	wwevent = WW_eventsetWW3();
	WW_configarray[no].packedww3 = WW_packevent(wwevent,WW_Eventlocalname,'WWParmSet3');
	wwevent = WW_eventfav();
	if(WW_isdefined(wwevent))	{
		WW_configarray[no].packedfav = WW_packevent(wwevent,WW_Eventlocalname,'WWFavorites'); }
	else 	{
		WW_configarray[no].packedfav = '';
	}
	return true;
	
}	// End WW_setconfig(no,username)

function WW_eventconfig(configno)	{ // Set Event corresponding to Given Configuration

	if(WW_isundefined(WW_configarray[configno]))
		return null;
	var wwevent = new WW_generatedevent(WW_username,WW_localflag,WW_tangogrouplabel,WW_tangosequencenumber,'config');
	wwevent.message = 'WWConfig System ' + WW_configarray[configno].systemname + ' User ' + WW_configarray[configno].username;
	wwevent.currenturl = WW_configarray[configno].currenturl;
	wwevent.username = WW_configarray[configno].username;
	wwevent.configtype = WW_configarray[configno].configtype; 
	wwevent.preferred = WW_configarray[configno].preferred;
	wwevent.masteroption = WW_configarray[configno].masteroption;
	return wwevent;
	
} 	// End WW_eventconfig(configno)

function WW_controlconfiglayer(configno)	{ // Display Configuration in Layer

	if(!WW_isitawindow(WW_consolewindow))	{
		WW_button_Console();
		WW_consolehandlerparm = configno;
		return true;
	}
	WW_controlconfiglayer1(configno);
	return true;
	
}	// End WW_controlconfiglayer(configno)

function WW_controlconfiglayer1(configno)	{ // Display Configuration in Layer after Console Loaded

	WW_consolehandlerparm = -1;
	WW_displayconfiglayer = WW_getlayer("WWconfiglayer",WW_consolewindow);
	if(WW_isdefined(WW_displayconfiglayer))	{ // WW_displayconfiglayer is layer for event options	
		var layertext = "<form name='displaylayeractions' ><input type=button value='Delete Layer!' onclick='bigboss.WW_hideconfigdisplaypage()'></form>"; 
		layertext += WW_displayconfig(configno);
		WW_changelayer(WW_displayconfiglayer,layertext,"pink",75,true);
	}
	return true;

}	// End WW_controlconfiglayer1(configno)

//	Handler called from Display Configuration Layer
function WW_hideconfigdisplaypage()	{	// Hide Configuration Display Page

	if(WW_isundefined(WW_displayconfiglayer))
		return true;
	WW_layerhide(WW_displayconfiglayer);
	WW_displayconfiglayer = null;

}	// End WW_hideconfigdisplaypage())

function WW_displayconfig(configno)	{ // Return Display Text corresponding to Given Configuration

	if(WW_isundefined(WW_configarray[configno]))
		return 'Null Configuration';
	layertext = '<b>Configuration ' + configno + ' User ' + WW_configarray[configno].username + ' type ' + WW_configarray[configno].configtype + '</b>'; 
	layertext += '<br><b>Preferred? </b>' + WW_configarray[configno].preferred + '<b> Master Option </b>' + WW_configlabel[WW_configarray[configno].masteroption];
	layertext += '<br><b>User URL </b>' + WW_configarray[configno].currenturl;
	layertext += '<br>' + WW_displayfav(WW_configarray[configno].packedfav);
	layertext += '<br>' + WW_displaysetWW1(WW_configarray[configno].packedww1);
	layertext += '<br>' + WW_displaysetWW2(WW_configarray[configno].packedww2);
	layertext += '<br>' + WW_displaysetWW3(WW_configarray[configno].packedww3);
	return layertext;
	
} 	// End WW_displayconfig(configno)

function WW_eventfav()	{ // Set Event Corresponding to Current Favorites

	if( WW_favorite_count == 0 )
		return null;
	var wwevent = new WW_generatedevent(WW_username,WW_localflag,WW_tangogrouplabel,WW_tangosequencenumber,'favorites');
	wwevent.message= 'WWfavorites';
	wwevent.currenturl = WW_userinput;
	wwevent.arraysize = WW_favorite_count;
	wwevent.arrayitself = new Array();
	for(var m=0; m <WW_favorite_count; m++)	{
		wwevent.arrayitself[m] = {};
		wwevent.arrayitself[m].currenturl = WW_listoffavorites[m];
	}
	return wwevent;
	
} 	// End WW_eventfav()

function WW_displayfav(packedevent)	{ // Return text corresponding to favorites stored in an event

	if(packedevent == '')
		return '';
	WW_testoneventtarget = false;
	var wwevent = new WW_basicevent();
	WW_getevent(packedevent,wwevent);
	WW_testoneventtarget = true;
	var num = wwevent.arraysize;
	if( num <= 0 )
		return '';
	var layertext = '<br><b>Favorites</b>';
	for(var m=0; m <num; m++)	{
		var localurl = wwevent.arrayitself[m].currenturl;
		layertext += '<br>' + localurl;
	}
	return layertext;

}	// End WW_displayfav(packedevent)

function WW_eventsetWW1()	{ // Put Parameters WW1 in Event Format

	var wwevent = new WW_generatedevent(WW_username,WW_localflag,WW_tangogrouplabel,WW_tangosequencenumber,'setparameter');
	wwevent.message = 'WWParmSet1';
	var num = 7;
	wwevent.parameternumber = -1;
	wwevent.arraysize = num;
	wwevent.arrayitself = new Array();
	for(var m=0; m <num;m++)	{
		wwevent.arrayitself[m] = {};
		wwevent.arrayitself[m].parameternumber = m;
		wwevent.arrayitself[m].logicalparametervalue = true;
	}
	wwevent.arrayitself[0].logicalparametervalue = WW_enforceformcommands;
	wwevent.arrayitself[1].logicalparametervalue = WW_acceptmasterforms;
	wwevent.arrayitself[2].logicalparametervalue = WW_usescroll;
	wwevent.arrayitself[3].logicalparametervalue = WW_allowformclick;
	wwevent.arrayitself[4].logicalparametervalue = WW_allowurlclick;
	wwevent.arrayitself[5].logicalparametervalue = WWTango_acceptmasterstyle;
	wwevent.arrayitself[6].logicalparametervalue = WWTango_canchangepointer;
	return wwevent;
	
}	// End WW_eventsetWW1()

function WW_eventsetWW2()	{ // Put Parameters WW2 in Event Format

	var wwevent = new WW_generatedevent(WW_username,WW_localflag,WW_tangogrouplabel,WW_tangosequencenumber,'setparameter');
	wwevent.message = 'WWParmSet2';
	var num = 3;
	wwevent.parameternumber = -2;
	wwevent.arraysize = num;
	wwevent.arrayitself = new Array();
	for(var m=0; m <num;m++)	{
		wwevent.arrayitself[m] = {};
		wwevent.arrayitself[m].parameternumber = m;
		wwevent.arrayitself[m].logicalparametervalue = true;
	}
	wwevent.arrayitself[0].logicalparametervalue = WW_closemostwindows;
	wwevent.arrayitself[1].logicalparametervalue = WW_deletepersonalbookmarks;
	wwevent.arrayitself[2].logicalparametervalue = WW_deletesystembookmarks;
	return wwevent;
	
}	// End WW_eventsetWW2()

function WW_eventsetWW3()	{ // Put Parameters WW3 in Event Format

	var wwevent = new WW_generatedevent(WW_username,WW_localflag,WW_tangogrouplabel,WW_tangosequencenumber,'setparameter');
	wwevent.message = 'WWParmSet3';
	var num = 2;
	wwevent.parameternumber = -3;
	wwevent.arraysize = num;
	wwevent.arrayitself = new Array();
	for(var m=0; m <num;m++)	{
		wwevent.arrayitself[m] = {};
		wwevent.arrayitself[m].parameternumber = m;
		wwevent.arrayitself[m].stringparametervalue = '';
	}
	wwevent.arrayitself[0].stringparametervalue = WW_smallimagestem;
	wwevent.arrayitself[1].stringparametervalue = WW_largeimagestem;
	return wwevent;
	
}	// End WW_eventsetWW3()

// Controlflag =0 ALL Sets; >0 Just this set
function WW_sendformparameters(controlflag)	{ // Send DHTML/Form Parameters from Master

	var heartflag =0;
	if( controlflag > 0 )
		heartflag =1;
	var wwevent;
	if( controlflag==0)	{
		var totalevent = new WW_generatedevent(WW_username,WW_localflag,WW_tangogrouplabel,WW_tangosequencenumber,'setparameter');
		totalevent.message = 'WWParmSet1 2 and 3';
		var num = 3;
		totalevent.parameternumber = 0;
		totalevent.arraysize = num;
		totalevent.arrayitself = new Array();
		totalevent.arrayitself[0] = WW_eventsetWW1();
		totalevent.arrayitself[1] = WW_eventsetWW2();
		totalevent.arrayitself[2] = WW_eventsetWW3();
		WW_accumandsendevent(totalevent,WW_Eventnonmastername,' Send Parametersets WW1 WW2 WW3',heartflag);
	}
	if( controlflag == 1)	{
		if(heartflag>0)
			WW_newtangolabel(WW_localflag,WW_tangogrouplabel);
		wwevent = WW_eventsetWW1();
		WW_accumandsendevent(wwevent,WW_Eventnonmastername,' Send Parameterset WW1',heartflag);
	}
	if( controlflag== 2 )	{
		if(heartflag>0)
			WW_newtangolabel(WW_localflag,WW_tangogrouplabel);
		wwevent = WW_eventsetWW2();
		WW_accumandsendevent(wwevent,WW_Eventnonmastername,' Send Parameterset WW2',heartflag);
	}
	if( controlflag== 3 )	{
		if(heartflag>0)
			WW_newtangolabel(WW_localflag,WW_tangogrouplabel);
		wwevent = WW_eventsetWW3();
		WW_accumandsendevent(wwevent,WW_Eventnonmastername,' Send Parameterset WW3',heartflag);
	}
	WW_parameterssent = true;
	return;

}	// End WW_sendformparameters(controlflag)

function WW_readformparameters(receivedevent)	{ // Read DHTML/Form Parameters from Master

	var test = receivedevent.parameternumber;
	if( test == 0 )	{
		var num = receivedevent.arraysize;
		if(num <= 0 )
			return false;
		var result = true;
		for(var m=0; m<num; m++)	{
			var childev = receivedevent.arrayitself[m];
			var ret1 = WW_readformparameters(childev);
			if(!ret1)
				result =false;
		}
		return result;
	}
	if(test ==  -1)
		return WW_readsetWW1(receivedevent,'Master');
	if(test ==  -2)
		return WW_readsetWW2(receivedevent,'Master');
	if(test ==  -3)
		return WW_readsetWW3(receivedevent,'Master');
	return false;

}	// End WW_readformparameters(receivedevent)

function WW_readsetWW1(receivedevent,sourcename)	{ // Read Packed Parameter Set WW1

	if(receivedevent.parameternumber != -1)
		return false;
	if( receivedevent.arraysize != 7 )
		return false;
	var cntchanges = 0;
	cntchanges += WW_readoneparm(3,"WW_enforceformcommands",0,receivedevent);
	cntchanges += WW_readoneparm(3,"WW_acceptmasterforms",1,receivedevent);
	cntchanges += WW_readoneparm(3,"WW_usescroll",2,receivedevent);
	cntchanges += WW_readoneparm(3,"WW_allowformclick",3,receivedevent);
	cntchanges += WW_readoneparm(3,"WW_allowurlclick",4,receivedevent);
	cntchanges += WW_readoneparm(3,"WWTango_acceptmasterstyle",5,receivedevent);
	cntchanges += WW_readoneparm(3,"WWTango_canchangepointer",6,receivedevent);
	if( cntchanges == 0 )
		return true;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writesharedformlayer(); }
	WW_startbarmessage(cntchanges + " Parameters WW1 changed by " + sourcename,10)
	return true;

}	// End WW_readsetWW1(receivedevent,sourcename)

function WW_readsetWW2(receivedevent,sourcename)	{ // Read Packed Parameter Set WW2

	if(receivedevent.parameternumber != -2)
		return false;
	if( receivedevent.arraysize != 3 )
		return false;
	var cntchanges = 0;
	cntchanges += WW_readoneparm(3,"WW_closemostwindows",0,receivedevent);
	cntchanges += WW_readoneparm(3,"WW_deletepersonalbookmarks",1,receivedevent);
	cntchanges += WW_readoneparm(3,"WW_deletesystembookmarks",2,receivedevent);
	if( cntchanges == 0 )
		return true;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writeloadpagelayer(); }
	WW_startbarmessage(cntchanges + " Parameters WW2 changed by " + sourcename,10)
	return true;

}	// End WW_readsetWW2(receivedevent,sourcename)

function WW_readsetWW3(receivedevent,sourcename)	{ // Read Packed Parameter Set WW3

	if(receivedevent.parameternumber != -3)
		return false;
	if( receivedevent.arraysize != 2 )
		return false;
	var cntchanges = 0;
	cntchanges += WW_readoneparm(0,"WW_smallimagestem",0,receivedevent);
	cntchanges += WW_readoneparm(0,"WW_largeimagestem",1,receivedevent);
	if( cntchanges == 0 )
		return true;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writenetworklayer(); }
	WW_startbarmessage(cntchanges + " Parameters WW3 changed by " + sourcename,10)
	return true;

}	// End WW_readsetWW3(receivedevent,sourcename)

// Set Single Parameter from array position and return 1 if changed
function WW_readoneparm(parmtype,setthis,indexpos,receivedevent)	{

	eval("var valsetthis =" +  setthis);
	var tempar;
	if( parmtype == 0)
		tempvar = receivedevent.arrayitself[indexpos].stringparametervalue;
	if( parmtype == 1)
		tempvar = receivedevent.arrayitself[indexpos].integerparametervalue;
	if( parmtype == 2)
		tempvar = receivedevent.arrayitself[indexpos].floatparametervalue;
	if( parmtype == 3)
		tempvar = receivedevent.arrayitself[indexpos].logicalparametervalue;
	if( tempvar == valsetthis )
		return 0;
	eval(setthis + "= tempvar");
	return 1;

}	// End WW_readoneparm(setthis,indexpos,receivedevent)

function WW_displaysetWW1(packedevent)	{ // Return HTML to display Parameter Set WW1 stored as a packed event

	if(packedevent == '')
		return '';
	WW_testoneventtarget = false;
	var wwevent = new WW_basicevent();
	WW_getevent(packedevent,wwevent);
	WW_testoneventtarget = true;
	if(wwevent.parameternumber != -1)
		return '';
	if( wwevent.arraysize != 7 )
		return '';
	var layertext = '<b><br>Parameter Set WW1</b>';
	layertext += WW_addparmtolayer(3,"WW_enforceformcommands",0,wwevent);
	layertext += WW_addparmtolayer(3,"WW_acceptmasterforms",1,wwevent);
	layertext += WW_addparmtolayer(3,"WW_usescroll",2,wwevent);
	layertext += WW_addparmtolayer(3,"WW_allowformclick",3,wwevent);
	layertext += WW_addparmtolayer(3,"WW_allowurlclick",4,wwevent);
	layertext += WW_addparmtolayer(3,"WWTango_acceptmasterstyle",5,wwevent);
	layertext += WW_addparmtolayer(3,"WWTango_canchangepointer",6,wwevent);
	return layertext;

}	// End WW_displaysetWW1(wwevent)

function WW_displaysetWW2(packedevent)	{ // Return HTML to display Parameter Set WW2 stored as a packed event

	if(packedevent == '')
		return '';
	WW_testoneventtarget = false;
	var wwevent = new WW_basicevent();
	WW_getevent(packedevent,wwevent);
	WW_testoneventtarget = true;
	if(wwevent.parameternumber != -2)
		return '';
	if( wwevent.arraysize != 3 )
		return '';
	var layertext = '<b><br>Parameter Set WW2</b>';
	layertext += WW_addparmtolayer(3,"WW_closemostwindows",0,wwevent);
	layertext += WW_addparmtolayer(3,"WW_deletepersonalbookmarks",1,wwevent);
	layertext += WW_addparmtolayer(3,"WW_deletesystembookmarks",2,wwevent);
	return layertext;

}	// End WW_displaysetWW2(wwevent)

function WW_displaysetWW3(packedevent)	{ // Return HTML to display Parameter Set WW3 stored as a packed event

	if(packedevent == '')
		return '';
	WW_testoneventtarget = false;
	var wwevent = new WW_basicevent();
	WW_getevent(packedevent,wwevent);
	WW_testoneventtarget = true;
	if(wwevent.parameternumber != -3)
		return '';
	if( wwevent.arraysize != 2 )
		return '';
	var layertext = '<b><br>Parameter Set WW3</b>';
	layertext += WW_addparmtolayer(0,"WW_smallimagestem",0,wwevent);
	layertext += WW_addparmtolayer(0,"WW_largeimagestem",1,wwevent);
	return layertext;

}	// End WW_displaysetWW3(wwevent)

function WW_addparmtolayer(parmtype,currentname,indexpos,wwevent)	{

	eval("var valcurrentname =" +  currentname);
	var tempar;
	if( parmtype == 0)
		tempvar = wwevent.arrayitself[indexpos].stringparametervalue;
	if( parmtype == 1)
		tempvar = wwevent.arrayitself[indexpos].integerparametervalue;
	if( parmtype == 2)
		tempvar = wwevent.arrayitself[indexpos].floatparametervalue;
	if( parmtype == 3)
		tempvar = wwevent.arrayitself[indexpos].logicalparametervalue;
	if( tempvar == valcurrentname )	{
		return ('<br><b>' + currentname + ' </b>= ' + tempvar + ' unchanged');
	}
	return ('<br><b>' + currentname + ' = ' + tempvar + ' current ' + valcurrentname + '</b>');

}	// End WW_addparmtolayer(currentname,indexpos,wwevent)

function WW_deleteconfiguration()	{	// Delete Current Configuration

	if( WW_selectedconfig <= 1 )	{
		WW_setstatusline('Cant Delete this');
		return true; }
	if( WW_selectedconfig >= WW_numconfigs)
		return true;	
	if(!WW_deleteconfigflag)	{
		WW_deleteconfigflag = true;
		WW_startbarmessage("Click Delete Again Quickly To Confirm",5);
		return true;
	}
	WW_deleteconfigflag = false;
	if( WW_selectedconfig >= WW_numconfigs )
		return true;
	if( WW_selectedconfig <= 1 )	{
		WW_setstatusline('Cant Delete this');
		return true; }
	for( var m = WW_selectedconfig; m < (WW_numconfigs-1); m++ )	{
		WW_configarray[m] = WW_configarray[m+1];
	}
	--WW_numconfigs;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writehistorylayer(); }
	else	{
		WW_button_Dialog(1); }
	return true;
	
}	// End WW_deleteconfiguration()

function WW_switchtoconfiguration()	{	// Switch to Selected Configuration
	
	if( WW_selectedconfig < 0 )
		return true;
	if( WW_selectedconfig >= WW_numconfigs )
		return true;
	WW_switchtofavorites(0);
	if( WW_tangostatus == 0 )	{ // Master Interpret Parameters
		WW_testoneventtarget = false;
		var wwevent = new WW_basicevent();
		WW_getevent(WW_configarray[WW_selectedconfig].packedww1,wwevent);
		WW_readsetWW1(wwevent,'Configuration ' + WW_configarray[WW_selectedconfig].username);
		WW_sendformparameters(1);
		wwevent = new WW_basicevent();
		WW_getevent(WW_configarray[WW_selectedconfig].packedww2,wwevent);
		WW_readsetWW2(wwevent,'Configuration ' + WW_configarray[WW_selectedconfig].username);
		WW_sendformparameters(2);
		wwevent = new WW_basicevent();
		WW_getevent(WW_configarray[WW_selectedconfig].packedww3,wwevent);
		WW_readsetWW3(wwevent,'Configuration ' + WW_configarray[WW_selectedconfig].username);
		WW_sendformparameters(3);
		WW_testoneventtarget = true;
	}
	for( var m = 0; m < WW_numconfigs; m++ )	{
		WW_configarray[m].preferred = false;
	}
	WW_configarray[WW_selectedconfig].preferred = true;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writehistorylayer(); }
	else	{
		WW_button_Dialog(1); }
	return true;
	
}	// End WW_switchtoconfiguration()

function WW_switchtofavorites(option)	{ // Switch Favorites of Selected Configuration

	if( WW_selectedconfig < 0 )
		return true;
	if( WW_selectedconfig >= WW_numconfigs )
		return true;
	WW_userinput = WW_configarray[WW_selectedconfig].currenturl;
	WW_testoneventtarget = false;
	var wwevent = new WW_basicevent();
	WW_getevent(WW_configarray[WW_selectedconfig].packedfav,wwevent);
	WW_testoneventtarget = true;
	var num = wwevent.arraysize;
	if( num <= 0 )
		return true;
	WW_listoffavorites = new Array();
	for(var m=0; m <num; m++)	{
		WW_listoffavorites[m] = wwevent.arrayitself[m].currenturl;
	}
	WW_favorite_count = num;
	WW_selectedfavorite= 0;
	if( option == 0 )
		return true;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writeloadpagelayer(); }
	else	{
		WW_button_Dialog(1); }
	return true;
	
}	// End WW_switchtofavorites(option)

function WW_saveconfiguration(newname)	{	// Save Current Configuration with Given name

	if( newname == '' )	{
		WW_startbarmessage("Please Specify Unique Name",10);
		return true; }
	for( var m = 0; m < WW_numconfigs; m++ )	{
		if(newname == WW_configarray[m].username)	{
			WW_startbarmessage("Please Specify Unique Name not " + newname,10);
			return true;
		}
	}
	WW_setconfig(WW_numconfigs,newname);
	++WW_numconfigs;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writehistorylayer(); }
	else	{
		WW_button_Dialog(1); }
	return true;

}	// End WW_saveconfiguration(newname)

// Save Current Configurations as Cookies Overwriting Previous entries
function WW_saveconfigsascookies()	{

	for( var m = 2; m < WW_numconfigs; m++ )	{
		var cookiename = 'WWJSSBConfig' + m;
		var wwevent = WW_eventconfig(m);
		var packedevent = WW_packevent(wwevent,WW_Eventlocalname,cookiename);
		WW_setcookie(cookiename,packedevent);
		WW_setcookie('WWJSSBFav' + m,WW_configarray[m].packedfav);
		WW_setcookie('WWJSSBParmWW1' + m,WW_configarray[m].packedww1)
		WW_setcookie('WWJSSBParmWW2' + m,WW_configarray[m].packedww2)
		WW_setcookie('WWJSSBParmWW3' + m,WW_configarray[m].packedww3)
	}
	cookiename = 'WWJSSBConfig' + WW_numconfigs;
	WW_setcookie(cookiename,'Theend');

}	// End WW_saveconfigsascookies()

// Save Current Configurations as Cookies Overwriting Previous entries
function WW_readconfigsfromcookies()	{

	var teststring = 'Theend';
	var packedevent = '';
	var newlen = WW_numconfigs;
	var newpref = -1;
	for( var m = WW_numconfigs; m < 20; m++ )	{
		var cookiename = 'WWJSSBConfig' + m;
		if( (packedevent=WW_getCookie(cookiename,teststring)) == teststring )
			break;
		var test1 = WW_getCookie('WWJSSBFav' + m,teststring);
		if( test1 == teststring )
			break;
		var test2 = WW_getCookie('WWJSSBParmWW1' + m,teststring);
		if( test2 == teststring )
			break;
		var test3 = WW_getCookie('WWJSSBParmWW2' + m,teststring);
		if( test3 == teststring )
			break;
		var test4 = WW_getCookie('WWJSSBParmWW3' + m,teststring);
		if( test4 == teststring )
			break;
		WW_testoneventtarget = false;
		var wwevent = new WW_basicevent();
		WW_getevent(packedevent,wwevent);
		var match = false;
		for(var mm = 0;mm< newlen; mm++)	{
			if(WW_configarray[mm].username == wwevent.username)	{
				match = true;
				break;
			}
		}
		if( match )
			continue;
		WW_configarray[newlen] = new WW_createconfig(newlen, '');
		WW_configarray[newlen].currenturl = wwevent.currenturl;
		WW_configarray[newlen].username = wwevent.username;
		WW_configarray[newlen].configtype = wwevent.configtype; 
	 	WW_configarray[newlen].preferred = wwevent.preferred;
		WW_configarray[newlen].masteroption = wwevent.masteroption;
		WW_testoneventtarget = true;
		WW_configarray[newlen].packedfav = test1;
		WW_configarray[newlen].packedww1 = test2;
		WW_configarray[newlen].packedww2 = test3;
		WW_configarray[newlen].packedww3 = test4;
		if( wwevent.preferred )
			newpref = newlen;
		++newlen;
	}
	WW_numconfigs = newlen;
	if( newpref < 0 )
		return true;
	WW_selectedconfig = newpref;
	WW_switchtoconfiguration();
	return true;

}	// End WW_readconfigsfromcookies()

function WW_saveandsendforms(arg,userlist)	{ // Save all forms in shared page
// Transmit result to user list if master and arg is 2
// Transmit result to Master if nonmaster and arg = 3

	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return false;
	import WW_spawnedparent.WW_saveforms;
	if(arg>=2)
		WW_newtangolabel(WW_localflag,WW_tangogrouplabel);
	var wwevent = new WW_generatedevent(WW_username,WW_localflag,WW_tangogrouplabel,WW_tangosequencenumber,'form');
	if( !WW_saveforms(wwevent)  )
		return false;
	var target = WW_Eventlocalname;
	var flag = -1;
	if( (WW_tangostatus==0) && (arg==2) )	{
		flag = 3;
		target = WW_Eventnonmastername;
		var len  = userlist.length;
		WW_tempparticipantlist.length = 0;
		for(var m=0; m<len; m++ )	{
			WW_tempparticipantlist[m] = userlist[m]; }
		WW_tempparticipantlist.length = len;
	}
	if( arg == 3 )	{
		WW_tempparticipantlist[0] = WW_mastername;
		target = WW_Eventmastername;
		WW_tempparticipantlist.length = 1;
		flag = 3;
	}
	WW_accumandsendevent(wwevent,target,' User Requested Form Save',flag);
	WW_tempparticipantlist.length = 0;
	if(WW_isitawindow(WW_dialogwindow))
		WW_dialogwindow.WW_writesharedformlayer();	
	return true;

}	// End WW_saveandsendforms(arg)

function WW_resetforms(eventm1)	{ // Reset Page Forms According to this Event

	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return false;
	import WW_spawnedparent.WW_interpretformevents;
	WW_interpretformevents(WW_eventrecord[eventm1],2);
	return true;

}	// End WW_resetforms(eventm1)

function WW_copyhistory(choosepart)	{ // Copy data from Header of History Page
// choosepart =1 Favorites =2 Events =3 Choose Configurations
// Use signed version to allow access to archived local data

	if(!WW_isitawindow(WW_historyparent))
		return;
	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return false;
	if(choosepart==2)	
		WW_resethistory(choosepart);
	import WW_spawnedparent.WW_signedcopyhistory;
	WW_signedcopyhistory(choosepart);
	WW_historyparent.WW_madebytango = true;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_button_Dialog(1); }
	return true;

}	// End WW_copyhistory(choosepart)

function WW_resethistory(choosepart)	{ // Reset Cumulative Arrays
// choosepart =1 Favorites =2 Events

	if( choosepart==1 )	{
		WW_selectedconfig =0;
		WW_switchtofavorites(1);
		return;
	}

	WW_unsetlastpointers();
	WW_numberurl =0;
	WW_numallevents =0;
	WW_numeventsdone = 0;
	WW_lasteventarchived = 0;
	WW_lasteventtoreplay = -1;
	WW_lastmajoreventarchived = 0;
	WW_numeventindicators = 0; // Unset Count  for Major Event Indicators
	WW_numonunload = 0;
	WW_numdynamictangoflag =0; // Number of undefinitions of Dynamic Tango Flags
	WW_numwisdomregister = 0;
	WW_numcompleteddocuments = 0; // Number of Document completions
	WW_tangogrouplabel = 'Initial Group'; // Group Label on Current Generation Stream
	WW_tangosequencenumber = 0; // Just leave one Sequence Number within Current Stream
	
	WW_majorevent.length =0;
	WW_eventrecord.length =0;
	WW_eventindicators.length =0;
	WW_onunloadevent.length =0;
	WW_dynamictangoflagevent.length =0;
	WW_wisdomregisterevent.length =0;
	WW_completeddocumentsevent.length =0;
	WW_labelstream.length =1;
	return;
	
	
}	// End WW_resethistory(choosepart)

function WW_saveandreloaddhtml()	{ // save current page including application dhtml
// Then reload page and refresh dhtml

	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return false;
	import WW_spawnedparent.WW_updatefullpointerparms;
	if(!WW_updatefullpointerparms(2))
		return false;
	WW_resetpointerto = WW_numallevents;
	WW_button_Restart(0);
	return true;

}	// End WW_saveandreloaddhtml()

function WW_updatefavorites(newurl)	{ // add new url to favorite list

	for(var m=0 ; m<WW_favorite_count ; m++)	{
		if(WW_listoffavorites[m] == newurl)
			return false;
		var lastchar = newurl.charAt(newurl.length-1);
		if( lastchar == '/' )	{
				var nexttest = WW_listoffavorites[m] + '/';
				if(nexttest == newurl)
					return false;
		}
	}
	WW_listoffavorites[WW_favorite_count] = newurl;
	++WW_favorite_count;
	if(WW_isitawindow(WW_dialogwindow))
		WW_dialogwindow.WW_writeloadpagelayer();
	return true;

}	// End WW_updatefavorites(newurl)

function WW_deletefavorite()	{ // Remove URL from favorite list

	var temptotal = WW_favorite_count;
	var tempbad = WW_selectedfavorite;
	if(temptotal <= 1 )
		return true;
	for(var m=tempbad ; m<(temptotal-1) ; m++)	{
		WW_listoffavorites[m] = WW_listoffavorites[m+1];
	}
	WW_selectedfavorite = tempbad-1;
	if( WW_selectedfavorite < 0 )
		WW_selectedfavorite = 0;
	WW_favorite_count = temptotal-1;
	if(WW_isitawindow(WW_dialogwindow))
		WW_dialogwindow.WW_writeloadpagelayer();
	return true;

}	// End WW_deletefavorite()

function WW_updatemapping()	{

	var localform = WW_getformhandle(1);
	if(localform == null )
		return true;
	WW_oldstem = localform.nonmasteroldstem.value;
	WW_newstem = localform.nonmasternewstem.value;
	return true;

}	// End WW_updatemapping()

function WW_pointerparm(useropt)	{

	if( useropt == -1 )
		return WWTango_acceptmasterstyle;
	if( useropt == -2 )
		return WWTango_canchangepointer;
	if( useropt == 1 )
		WWTango_acceptmasterstyle = localform.pointermasterstylechange.checked;
	if( useropt == 2 )
		WWTango_canchangepointer = localform.pointerlocalstylechange.checked;
	if( WW_tangostatus == 0 )
		return;
	var result = true;
	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return result;
	import WW_spawnedparent.WW_spawnedframeset;
	var pointerframeset = WW_spawnedframeset();
	var loopct = 1;
	var pointerframe = null;
	if( pointerframeset.childnum > 1 )
		loopct += pointerframeset.childnum ;
	for(var m=0; m < loopct; m++)	{
		if( m == 0 )	{
			pointerframe = pointerframeset.mainpage; }
		if( m > 0 )	{
			pointerframe = pointerframeset.framepages[m-1]; }
		if(!WW_isitawindow(pointerframe))
			continue;
		if(WW_isundefined(pointerframe.WWTango_pointertarget))
			continue;
		if(WW_isundefined(pointerframe.WW_isloaded))
			continue;
		if( pointerframe.WW_isloaded != 1 )
			continue;
		var localform = WW_getformhandle(5);
		if(localform == null )
			continue;
		if( useropt == 1 )
			pointerframe.WWTango_acceptmasterstyle = WWTango_acceptmasterstyle;
		if( useropt == 2 )
			pointerframe.WWTango_canchangepointer = WWTango_canchangepointer;
	}
	return result;

}	// End WW_pointerparm(useropt) set parameters for shared pointer

// type =0 ERROR =1 Java Console =2 Dialog Status =3 Dialog Debug
function WW_saveconsole(message,type)	{

	WW_freewindow = WW_getspawnedframe('freewindow');
	var tickcount = -1;
	if(WW_freewindow != null)
		tickcount = WW_freewindow.WW_countcycles;
	if( type < 0 )
		return tickcount;
	WW_consoleentry[WW_countconsolemessages] = {};
	WW_consoleentry[WW_countconsolemessages].message = message;
	WW_consoleentry[WW_countconsolemessages].type = type;
	WW_consoleentry[WW_countconsolemessages].sequencenumber = WW_tangosequencenumber;
	WW_consoleentry[WW_countconsolemessages].tickcount = tickcount;
	WW_consoleentry[WW_countconsolemessages].numpointereventsdone = WW_numpointereventsdone;
	WW_consoleentry[WW_countconsolemessages].numeventsdone = WW_numeventsdone;
	++WW_countconsolemessages;
	return tickcount;

}	// End WW_saveconsole(message,type)

function WW_settempjavaconsole(message)	{	// Don't save on console

	var tickcount = WW_saveconsole(message,-1);
	Packages.java.lang.System.out.println(tickcount + ':' + message);
	return true;

}	// End WW_settempjavaconsole(message)

function WW_setjavaconsole(message)	{

	var tickcount = WW_saveconsole(message,1);
	Packages.java.lang.System.out.println(tickcount + ':' + message);
	return true;

}	// End WW_setjavaconsole(message)

function WW_seterrorline(message)	{

	var tickcount = WW_saveconsole(message,0);
	var localform = WW_getformhandle(0);
	if(localform == null )
		return true;
	if(WW_isundefined(localform.wwjssbstatus))
		return true;
	localform.wwjssbstatus.value = tickcount + ':ERROR ' + message;
	return true;
 
}	 // End WW_seterrorline(message)

function WW_setstatusline(message)	{

	var tickcount = WW_saveconsole(message,2);
	var localform = WW_getformhandle(0);
	if(localform == null )
		return true;
	if(WW_isundefined(localform.wwjssbstatus))
		return true;
	localform.wwjssbstatus.value = tickcount + ':' + message;
	return true;
 
}	 // End WW_setstatusline(message)

function WW_settempstatusline(message)	{ // Don't Save in Console

	var tickcount = WW_saveconsole(message,-1);
	var localform = WW_getformhandle(0);
	if(localform == null )
		return true;
	if(WW_isundefined(localform.wwjssbstatus))
		return true;
	localform.wwjssbstatus.value = tickcount + ':' + message;
	return true;
 
}	 // End WW_settempstatusline(message)

function WW_setdebugline(message)	{

	var tickcount = WW_saveconsole(message,3);
	if(!WW_debugmode)
		return true;
	var localform = WW_getformhandle(0);
	if(localform == null )
		return true;
	if(WW_isundefined(localform.debugline))
		return true;
	localform.debugline.value =  tickcount + ':' + message;
	return true;
 
}	 // End WW_setdebugline(message)

function WW_dosubsturl(cururl,oldstem,newstem)     {
        var extractlen = oldstem.length;
        var junk = cururl.substring(0,oldstem.length);
        if( junk != oldstem )
                return(cururl);
        return(newstem + cururl.substring(oldstem.length) );
		
}       // End WW_dosubsturl(cururl,oldstem,newstem)

function WW_getbosswidth()	{
	return WW_spawnedwindowwidth;
}
function WW_getbossheight()	{
	return WW_spawnedwindowheight;
}
function WW_getnewstem()   {
        return WW_newstem;
}
function WW_getoldstem()   {
        return WW_oldstem;
}

function WW_getspawnedframe(framename)    {

	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return null;
	import WW_spawnedparent.WW_getframehandle;
	return WW_getframehandle(framename);

}	// End WW_getspawnedframe(framename)


function WW_setframesfrominfo(info)    {

	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return null;
	import WW_spawnedparent.WW_spawnedsetframesfrominfo;
	WW_spawnedsetframesfrominfo(info);
	return;

}	// end WW_setframesfrominfo(info)

function WW_isitaspawnedwindow(windowp)	{

	if( !WW_spawnedparentdone )
		return false; 
	return WW_isitawindow(windowp);

}	// End WW_isitaspawnedwindow(windowp)

// ************************** Set of Routines to Process Button Bar ************************
//	* Process Bar Clicks * mess is message * num1 labels window * num2 labels part of window
// Button Parameters
// fiveway = -1 Clock 0 Image 1 5 way =2 7 way =3 4 way click
// yesno =0 Grey Out =1 Active
function WW_barbuttonclick(mess,num1,num2)	{

	var statmess = mess + ' ' + WW_buttonspec.message[num1];
	WW_settempstatusline(statmess);
	if(WW_isitaspawnedwindow(WW_spawnedparent))	{
		import WW_spawnedparent.WW_setspawnedwindowstatus;
		WW_setspawnedwindowstatus(statmess); }
	if( num1 == 7 )	{ // Previous URL
		if(WW_prevheuristicurl == '' )
			return true;
		WW_button_Start(WW_prevheuristicurl);
		return true;
	}
	if( num1 == 8 )	{ // Next URL
			if(WW_nextheuristicurl == '' )
				return true;
			WW_button_Start(WW_nextheuristicurl);
			return true;
	}
	if( num1 > 4 )
		return true;
	if( num1>0 )	{
		var actualwindow = WW_getwindowobject(num1);
		if( num1 == 1 )	{ // review window
			if( WW_reviewmode == 3 )	{
				import WW_spawnedparent.WW_cardhandalignfocus;
				WW_cardhandalignfocus(num2);
				return true;
			}
			if(WW_isundefined(actualwindow) )	{
				WW_button_Review(1);
				return true; }
		}
		if( num1 ==2 )	{
			if(WW_isundefined(actualwindow))	{
				WW_createhistory(); return true; }
			import WW_spawnedparent.WW_signedconfirm;
			if( WW_signedconfirm("History Exists -- If you want to update, please OK") )	{
				WW_createhistory(); return true; }
		}
		if( (num1 ==3) && (WW_isundefined(actualwindow)) )	{
			if( WW_statusmode == 0)	{
				WW_createurlclone(); }
			else	{
				if( WW_statusmode == 1)	{
					WW_button_Status(); }
				else	{
					WW_button_Console(); }
			}
			return true;
		}
		if( (num1 ==4) && (WW_isundefined(actualwindow)) )	{
			WW_button_Dialog(1); return true; }
		WW_alignfocuswindow(actualwindow,num2);
		return true;
	}
	if( WW_buttonspec.yesno[num1] == 0 )
		return true;
	if(num1 == 0)	{ // Secure Window
		if(!WW_isitaspawnedwindow(WW_spawnedparent))
			return true;
		import WW_spawnedparent.WW_spawnedalignfocus;
		WW_spawnedalignfocus(num2);
		return true;
	}
	var actualwindow = WW_getwindowobject(num1);
	WW_alignfocuswindow(actualwindow,num2);
	return true;
	
}	// End WW_barbuttonclick(mess,num1,num2)

function WW_getwindowobject(num1)	{ // return handle for window indexed by num1

	var actualwindow = null;
	if( num1 == 0 )	{
		actualwindow = WW_spawnedparent;
		if(!WW_isitaspawnedwindow(WW_spawnedparent))
			actualwindow = null;
		return actualwindow;
	}
	if( num1 == 1 )	{
		if( WW_reviewmode != 3 )
			actualwindow = WW_reviewwindow; 
	}
	if( num1 == 2 )
		actualwindow = WW_historyparent;
	if( num1 == 3 )	{
		if(WW_statusmode == 0)	{
			actualwindow = WW_historytarget; }
		else	{
			if(WW_statusmode == 1)	{
				actualwindow = WW_statuswindow; }
			else	{
				actualwindow = WW_consolewindow; }
		}
	}
	if( num1 == 4 )
		actualwindow = WW_dialogwindow;
	if(!WW_isitawindow(actualwindow))
		actualwindow = null;
	return actualwindow;

}	// End WW_getwindowobject(num1)

function WW_barbuttonover(mess,num1,num2)	{
	var statmess = mess;
	if(num1 >= 0 )	{
		var extra = '';
		if( WW_buttonspec.yesno[num1] == 0 )
			extra = ' Disabled';
		statmess = mess + ' ' + WW_buttonspec.message[num1] + extra;
	}
	WW_settempstatusline(statmess);
	if(WW_isitaspawnedwindow(WW_spawnedparent))	{
		import WW_spawnedparent.WW_setspawnedwindowstatus;
		WW_setspawnedwindowstatus(statmess); }
	return true;
	
}	// End WW_barbuttonover(mess,num1,num2)

function WW_barbuttonout()	{
	var statmess = '';
	if( WW_numberurl > 0 )
		WW_settempstatusline(WW_majorevent[WW_numberurl-1].label);
	else	{
		WW_settempstatusline(statmess); }
	if(WW_isitaspawnedwindow(WW_spawnedparent))	{
		import WW_spawnedparent.WW_setspawnedwindowstatus;
		WW_setspawnedwindowstatus(statmess); }
	return true;
	
}	// End WW_barbuttonout()

function WW_buttonbar()	{

	this.nbutton = maxbuttonbarsize;
	this.yesno = new Array(maxbuttonbarsize);
	this.fiveway = new Array(maxbuttonbarsize);
	this.baseurl = WW_cleanupurl(WW_thisdocumentURLpath + "../whiteboard/barbuttons/");
	this.imageurl = new Array(maxbuttonbarsize);
	this.message = new Array(maxbuttonbarsize);
	this.ignore = new Array(maxbuttonbarsize);
	this.width = new Array(maxbuttonbarsize);
	this.height = new Array(maxbuttonbarsize);
	this.imgpos = new Array(maxbuttonbarsize);
	for (var m=0;m<maxbuttonbarsize;m++)	{
		this.yesno[m] = 1;
		this.fiveway[m]=1;
		this.message[m]="";
		this.ignore[m] = 1;
		this.width[m] =100;
		this.height[m] = 40;
		this.imgpos[m] = m;
	}
	
}	// End WW_buttonbar() Constructor

function  WW_buttonbarclone(oldbar,newbar)	{
	
	var num = oldbar.nbutton;
	newbar.nbutton = num;
	newbar.baseurl = oldbar.baseurl;
	for(var m=0;m<num;m++)    {
		newbar.yesno[m] = oldbar.yesno[m]
		newbar.fiveway[m] = oldbar.fiveway[m]
		newbar.message[m] = oldbar.message[m]
		newbar.ignore[m] = oldbar.ignore[m]
		newbar.width[m] = oldbar.width[m]
		newbar.height[m] = oldbar.height[m]
		newbar.imgpos[m] = oldbar.imgpos[m]
		newbar.imageurl[m] = oldbar.imageurl[m]
	}
	
}	// End WW_buttonbarclone(oldbar,newbar)

function WW_buttonbarchanged(oldbar,newbar)  {
        
	var num = newbar.nbutton
	if( num != oldbar.nbutton)
		return 2;
	if( oldbar.baseurl != newbar.baseurl )
		return 2;
	for(var m=0;m<num;m++)    {
	if( newbar.ignore[m] != oldbar.ignore[m] )
		return 2;
	if( newbar.ignore[m] == 1 )
		continue;
	if( newbar.yesno[m] != oldbar.yesno[m] )
		return 1;
	if( newbar.imageurl[m] != oldbar.imageurl[m] )
		return 1;
	if( newbar.fiveway[m] != oldbar.fiveway[m] )
		return 2;
	if( newbar.message[m] != oldbar.message[m] )
		return 1;
	if( newbar.width[m] != oldbar.width[m] )
		return 2;
	if( newbar.height[m] != oldbar.height[m] )
		return 2;
	if( newbar.imgpos[m] != oldbar.imgpos[m] )
		return 2;
	}
	return 0;
	
}	// End WW_buttonbarchanged(oldbar,newbar)

var WW_countupdatecalls =0; // sometimes Images wrong so allow refresh
function WW_updatebuttonbar() {

	if(!WW_isitawindow(WW_topcontrolwindow))
		return;
	if( WW_topcontrolwindowreadytogo == 0 )
		return;
	var preparestatus = WW_preparebuttonbar(0);
	++WW_countupdatecalls;
	if((preparestatus == 0) && (WW_countupdatecalls>=50) )
		preparestatus = 1;
	if( preparestatus > 0 )   {
		if(preparestatus == 1 )	{ // Just Change Image
			for( var m =0; m < WW_buttonspec.nbutton; m++)        {
				if( WW_buttonspec.ignore[m] == 1 )
					continue;
				if( (WW_countupdatecalls<50) &&(WW_buttonspec.yesno[m] == WW_buttonclone.yesno[m]) && (WW_buttonspec.imageurl[m] == WW_buttonclone.imageurl[m]) )
					continue;
				import WW_topcontrolwindow.changeimage;
				changeimage(m);
			}
			if(WW_countupdatecalls >= 50)
				WW_countupdatecalls =0;
			return;
		}
		if(WW_isitaspawnedwindow(WW_spawnedparent))	{
			import WW_spawnedparent.WW_createdestroybuttonbar;
			WW_createdestroybuttonbar(); }
        }
        return;
		
}	// End WW_updatebuttonbar()

function WW_preparebuttonbar(forced)	{

	if( forced == 0 )
		 WW_buttonbarclone(WW_buttonspec,WW_buttonclone);
	WW_setupbuttonbar(WW_buttonspec);
	if( forced == 1 )
		return 2;
	var buttonstatus = WW_buttonbarchanged(WW_buttonspec,WW_buttonclone);
	if( buttonstatus == 2 )
		return buttonstatus;
	if(!WW_isitawindow(WW_topcontrolwindow) )
		return 2;
	if( WW_topcontrolwindowreadytogo == 0 )
		return 2;
	return buttonstatus;

}	// End WW_preparebuttonbar(forced)

function WW_setupbuttonbar(buttonbarobject)	{

	for( var m =0; m < buttonbarobject.nbutton; m++)	{
		buttonbarobject.yesno[m] = 1;
		buttonbarobject.ignore[m] = 1; }
	buttonbarobject.yesno[1] = 0;
	for( var m=0; m<WW_barlayoutsize; m++)	{
		buttonbarobject.ignore[WW_barlayout[m]] = 0; }
	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		buttonbarobject.yesno[0] = 0;
	else	{
		if( WW_operatingmode == 3 )	{
			import WW_spawnedparent.WW_cardhandalignfocus;
			if( WW_cardhandalignfocus(-1) )	{
				buttonbarobject.yesno[1] = 1; }
			else	{
				buttonbarobject.yesno[1] = 0; }
		}
	} 
	if( WW_operatingmode != 3 )	{
		if( WW_isitawindow(WW_reviewwindow) )
			buttonbarobject.yesno[1] = 1;
		else	{
			buttonbarobject.yesno[0] = 0; }
	}
	if( !WW_tangogameinprogress )
		WW_mainurl = WW_defaultmainurl;
	WW_buttonspec.imageurl[0] = WW_mainurl;
	WW_buttonspec.imageurl[1] = WW_reviewfilename[WW_reviewmode] + '.gif';
	WW_buttonspec.message[1] = WW_reviewmessage[WW_reviewmode];
	if(!WW_isitawindow(WW_historyparent))
		buttonbarobject.yesno[2] = 0;
	if((WW_statusmode==1)&&(!WW_isitawindow(WW_statuswindow)))
		buttonbarobject.yesno[3] = 0;
	if((WW_statusmode==0)&&(!WW_isitawindow(WW_historytarget)))
		buttonbarobject.yesno[3] = 0;
	if((WW_statusmode==2)&&(!WW_isitawindow(WW_consolewindow)))
		buttonbarobject.yesno[3] = 0;
	WW_buttonspec.imageurl[3] = WW_statusfilename[WW_statusmode] + '.gif';
	WW_buttonspec.message[3] = WW_statusmessage[WW_statusmode];
	if(!WW_isitawindow(WW_dialogwindow))
		buttonbarobject.yesno[4] = 0;
	WW_buttonspec.imageurl[6] = WW_squareimage[WW_processingerrorflag] + '.gif';
	WW_buttonspec.message[6]= WW_squaremessage[WW_processingerrorflag];
	buttonbarobject.yesno[7] = 0;
	buttonbarobject.yesno[8] = 0;
	if(WW_prevheuristicurl != '' )
		buttonbarobject.yesno[7] = 1;
	if(WW_nextheuristicurl != '' )
		buttonbarobject.yesno[8] = 1;
	return;

} // End WW_setupbuttonbar(buttonbarobject)

// fnsew = 5 Focus ** =1 Top Left  ** = 3 Top Right ** = 2 Bottom Left ** =4 Bottom Right
function WW_alignfocuswindow(windowname,fnsew)	{ 
	if( !WW_isitawindow(windowname) )
		return;
	if( fnsew == 0 )	{
		windowname.focus();
		return; }
	var usexpos = parseInt(WW_userwindowxpos);
	var useypos = parseInt(WW_userwindowypos);
	if( fnsew == 1 )	{
		windowname.moveTo(usexpos,useypos);
		windowname.focus();
		return; }
	var xpos = screen.width;
	var ypos = screen.height;
	var xpos1 = windowname.outerWidth;
	var ypos1 = windowname.outerHeight;
	if( fnsew == 3 )
		windowname.moveTo(xpos-xpos1,useypos);
	if( fnsew == 2 )
		windowname.moveTo(usexpos,ypos-ypos1);
	if( fnsew == 4 )
		windowname.moveTo(xpos-xpos1,ypos-ypos1);
	windowname.focus();
	return;

}	// End WW_alignfocuswindow(windowname,fnsew)

// Display a Bar Message and set Trap to Remove it
function WW_startbarmessage(thetext,thetime)	{

	if(WW_freewindow == null)
		return true;
	var tickcount = WW_freewindow.WW_countcycles;

	if(WW_isitaspawnedwindow(WW_topcontrolwindow))	{
		import WW_topcontrolwindow.WW_makebarmessage;
		WW_barmessagelimit = tickcount + thetime*WW_clockunits;
		WW_makebarmessage(thetext,'pink'); }
	return true;

}	// End WW_startbarmessage(thetext,thetime)

// Remove Bar Message
function WW_removebarmessage()	{

	WW_deleteconfigflag = false;
	WW_barmessagelimit = -1;
	if(WW_isitaspawnedwindow(WW_topcontrolwindow))	{
		import WW_topcontrolwindow.WW_hidebarmessage;
		WW_hidebarmessage();
	}
	return true;

}	// End WW_removebarmessage()

// ********************** Routines to Process Clock *******************************

// eventindicator > 3 reset to 3 inside Control Bar
function WW_sendaddcoloredhand(eventindicator)	{

	if(!WW_isitawindow(WW_topcontrolwindow))
		return;
	if( WW_topcontrolwindowreadytogo == 0 )
		return;
	import WW_topcontrolwindow.WW_addcoloredhand;
	WW_addcoloredhand(eventindicator);
	return;

}	// End WW_sendaddcoloredhand(eventindicator)

function WW_sendclocktick()	{

	if(!WW_isitawindow(WW_topcontrolwindow))
		return;
	if( WW_topcontrolwindowreadytogo == 0 )
		return;
	import WW_topcontrolwindow.WW_clocktick;
	WW_clocktick();
	return;

}	// End WW_sendclocktick()

// Return true if no change in window size or if change rejected
function WW_checkwindowsize(wwevent)	{	


	if(WW_ignoreresize == 0)
		return true;
	if(WW_isundefined(wwevent.innerheight))
		return true;
	if(WW_isundefined(wwevent.innerwidth))
		return true;
	if(!WW_isitaspawnedwindow(WW_spawnedparent))
		return true;
	import WW_spawnedparent.WW_getspawnedwidth;
	var curwidth = WW_getspawnedwidth();
	import WW_spawnedparent.WW_getspawnedheight;
	var curheight = WW_getspawnedheight();
	var ydiff = Math.abs(curheight - wwevent.innerheight);
	var xdiff = Math.abs(curwidth - wwevent.innerwidth);
	if( (xdiff < 3) && (ydiff < 3) )
		return true;
	import WW_spawnedparent.WW_signedconfirm;
	if( WW_ignoreresize==1 )	{
		if( WW_signedconfirm("Resize Requested -- Press OK to accept") )	{
			WW_ignoreresize = 2;
			if(WW_isitawindow(WW_dialogwindow))
				WW_dialogwindow.WW_setignoreresizeradiobutton();
		}
		else	{
			WW_ignoreresize = 0;
			if(WW_isitawindow(WW_dialogwindow))
				WW_dialogwindow.WW_setignoreresizeradiobutton();
			return true;
		}
	}
	import WW_spawnedparent.WW_spawnedparentclose;
        WW_spawnedparentclose();
 	if(WW_isundefined(wwevent.currenturl) && (wwevent.currenturl != '') )	{
 		import WW_spawnedparent.WW_getspawnedmainframeurl;
 		WW_targeturl = WW_getspawnedmainframeurl();
 		wwevent.currenturl = WW_targeturl;
 	}
 	else	{
 		WW_targeturl = wwevent.currenturl;
 	}
	wwevent.infotype = 1;
	wwevent.processed = 1;
	wwevent.type = 'windowsize';
	wwevent.majorevent = WW_numberurl;
	WW_numeventsdone = WW_numallevents; // don't process waiting form events
	WW_numpointereventsdone = WW_numallevents; // don't process waiting pointer events
	WW_spawnedwindowwidth = wwevent.innerwidth;
	WW_spawnedwindowheight = wwevent.innerheight;
	WW_majoreventprocess = 0;
	WW_startspawnedwindow();
	return false;

}	// End WW_checkwindowsize(wwevent)

//	Register Wisdom Pages
function WW_wisdomregister(level,pagetype,pagelabel,originatingwindow)	{

	WW_setdebugline('TangoBoss ' + level + ' ' + pagetype + ' ' + pagelabel);
	return;
	
}	// End WW_wisdomregister(level,pagetype,pagelabel,originatingwindow)

// Performance Package ***************************************************

// Generate timeprobe events to participants in sendlist
// if sendlist is zero length, send to all participants
function WW_sendtimeprobe(flag,sendlist)	{

	if(!WW_jssbusers[0].netmaster)
		return; // Only netmasters can send such events
	++WW_controlsequence;
	var wwevent = new WW_generatedevent(WW_username,WW_localnetflag,WW_controlgroup,WW_controlsequence,'timeprobe');
 	if( WW_tangostatus == 0 )
		wwevent.adminmaster = true;
	if( WW_jssbusers[0].netmaster)
		wwevent.netmaster = true;
	wwevent.infotype = 7;
	wwevent.timeprobeflag = flag;
	var num = 0;
	wwevent.arrayitself = new Array();
	for(var m =1; m<WW_numjssbusers; m++ )	{
		if(!WW_jssbusers[m].active)
			continue;
		if(!WW_jssbusers[m].netmaster)
			continue;
		var childevent = new WW_childevent('timeprobe');
		childevent.sourcename = WW_jssbusers[m].name;
		wwevent.arrayitself[num] = childevent;
		++num;
	}
	wwevent.arraysize = num;
	if( sendlist.length > 0 )	{
		wwevent.targetname = sendlist.toString();
	}
	var mess = WW_packevent(wwevent,WW_Eventtimename,'Time Probe with Flag ' + flag);
	if( sendlist.length > 0 )	{
		Tango_selectiveSend(sendlist,mess);
	}
	else	{
		Tango_send(mess);
	}
	WW_sendaddcoloredhand(2);
	wwevent.majorevent = WW_numberurl;
	wwevent.minorevent = WW_numallevents+1;
	WW_eventrecord[WW_numallevents] = WW_cloneevent(wwevent);
	++WW_numallevents;
	

}	// End WW_sendtimeprobe(flag,sendlist)

// Make and send an update event
// This may not work if Tango does not have Master as Admin Master
// Message will be discarded if sent to wrong master
function WW_updatestate(flag)	{ // Send Update Request to Master

	++WW_controlsequence;
	var wwevent = new WW_generatedevent(WW_username,WW_localnetflag,WW_controlgroup,WW_controlsequence,'update');
	wwevent.targetname = WW_mastername;
	wwevent.infotype = 7;
	wwevent.updateflag = flag; // flag=1 Initiate (Request Hearbeat) flag=2 Participant List request Flag = 3 Returned Participant list
	var touserarray = new Array(WW_mastername);
	var mess = WW_packevent(wwevent,WW_Eventmastername,WW_username + ' Requesting Update from ' + WW_mastername);
	Tango_selectiveSend(touserarray,mess);
	WW_sendaddcoloredhand(2);
	wwevent.majorevent = WW_numberurl;
	wwevent.minorevent = WW_numallevents+1;
	WW_eventrecord[WW_numallevents] = WW_cloneevent(wwevent);
	++WW_numallevents;
	
}	// End WW_updatestate(flag)

// Send Participant list
function WW_sendparticipantlist(recipientname)	{

	if(WW_tangoboss == 0 )
		return;
	++WW_controlsequence;
	var wwevent = new WW_generatedevent(WW_username,WW_localnetflag,WW_controlgroup,WW_controlsequence,'update');
	wwevent.targetname = recipientname;
	wwevent.infotype = 7;
	wwevent.updateflag = 3;
	var fromuserindex = WW_finduserbyname(recipientname);
	if( fromuserindex > 0 )	{
		if( WW_isdefined(WW_jssbusers[fromuserindex].averageskew) )
			wwevent.timeskew = WW_jssbusers[fromuserindex].averageskew; // Add this to master times to get Non Master times
	}
	var num = WW_numjssbusers;
	wwevent.arraysize = num;
	wwevent.arrayitself = {};
	for( var m=0; m<num; m++)	{
		var childevent = new WW_childevent('update');
		childevent.netmaster = WW_jssbusers[m].netmaster;
		childevent.adminmaster = WW_jssbusers[m].masterstatus;
		childevent.sourcename = WW_jssbusers[m].name;
		childevent.starttime = WW_jssbusers[m].starttime;
		childevent.endtime = WW_jssbusers[m].endtime;
		childevent.active = WW_jssbusers[m].active;
		wwevent.arrayitself[m] = childevent;
	}
	WW_tempparticipantlist[0] = recipientname;
	WW_tempparticipantlist.length = 1;
	WW_accumandsendevent(wwevent,WW_Eventnonmastername,'Participant List from Master',3);
	WW_tempparticipantlist.length = 0;
	return true;

}	// End WW_sendparticipantlist(recipientname)

function WW_readparticipantlist(receivedevent)	{

	if( WW_isdefined(receivedevent.timeskew))	{
		WW_jssbusers[0].averageskew = receivedevent.timeskew; // Subtract this from this client times to get master time
	}
	var num = receivedevent.arraysize;
	WW_numjssbusers = 1;
	WW_jssbusers.length = 1;
	for(var m=0; m<num; m++)	{
		var childevent = receivedevent.arrayitself[m];
		if( (childevent.sourcename == WW_username) && (childevent.active) )
			continue;
		WW_jssbusers[WW_numjssbusers] = new WW_jssbparticipant(childevent.sourcename,WW_numjssbusers+1);
		WW_jssbusers[WW_numjssbusers].netmaster = childevent.netmaster;
		WW_jssbusers[WW_numjssbusers].masterstatus = childevent.adminmaster;
		WW_jssbusers[WW_numjssbusers].starttime = childevent.starttime + WW_jssbusers[0].averageskew;
		WW_jssbusers[WW_numjssbusers].endtime = childevent.endtime + WW_jssbusers[0].averageskew;
		WW_jssbusers[WW_numjssbusers].active = childevent.active;
		if( childevent.adminmaster)
			WW_mastername = childevent.sourcename;
		++WW_numjssbusers;
	}
	
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writesharedformlayer();
		WW_dialogwindow.WW_writeloadpagelayer();
		WW_dialogwindow.WW_writenetworklayer(); }

}	// End WW_readparticipantlist(receivedevent)

// Read timeprobe synchronization request or measured time events: infotype=7
function WW_readprobe(receivedevent)	{
	
	receivedevent.processed = 1;
	if( receivedevent.type == 'update' )	{ // Participant Requests or Gets Update
		var updateflag = receivedevent.updateflag;
		if( updateflag <= 2 )	{	// Request to Master for Participant List (flag = 1 or 2)
			if(WW_isundefined(receivedevent.sourcename))
				return;
			WW_sendparticipantlist(receivedevent.sourcename);
			return;
		}
		if( updateflag == 3 )	{	// Process Returned Participant List
			WW_readparticipantlist(receivedevent);
			return;
		}
		if( updateflag == 1 )	{	// Send Heartbeat Information as soon as possible
			var tosendto = receivedevent.sourcename;
			WW_waitingparticipantlist.push(tosendto);
			WW_setdebugline(' Request for Update from ' + tosendto);
			return;
		}
	}
	var requestflag = receivedevent.timeprobeflag;
	if( receivedevent.type == 'measuredtime' )	{ // Store Data Returned to this site
		var fromuser = receivedevent.sourcename;
		if(WW_isundefined(fromuser))	{
			WW_setstatusline('Undefined Source User Name in measured time event ' + (WW_numallevents+1).toString());
			return;
		}
		var fromuserindex = WW_finduserbyname(fromuser);
		if( fromuserindex<0 )	{
			WW_setstatusline('Unknown Source User Name ' + fromuser + ' in measured time event ' + (WW_numallevents+1).toString());
			return;
		}
		var currenttime = receivedevent.targettime;
		if( requestflag == 1 )	{ // Unpack Ping Event -- add to previous ones
			var storeindex = WW_jssbusers[fromuserindex].numpings;
			WW_jssbusers[fromuserindex].pingrecord[storeindex] = {};
			WW_jssbusers[fromuserindex].pingrecord[storeindex].sendtime = receivedevent.dispatchsourcetime;
			WW_jssbusers[fromuserindex].pingrecord[storeindex].arrivetime = receivedevent.sourcetime;
			WW_jssbusers[fromuserindex].pingrecord[storeindex].backtime = currenttime;
			++WW_jssbusers[fromuserindex].numpings;
			return;
		}
		if( requestflag == 2 )	{ // Unpack Download Events -- Overwrite previous ones
			var num = receivedevent.arraysize;
			WW_jssbusers[fromuserindex].numdownloads = num;
			WW_jssbusers[fromuserindex].downloadrecord.length = num;
			if(num <= 0 )
				return;
			for( var m=0; m<num; m++)	{
				var summaryobject = {};
				var childevent = receivedevent.arrayitself[m];
				summaryobject.label = childevent.downloadlabel;
				summaryobject.timestarted = childevent.timestarted;
				summaryobject.average = childevent.average;
				summaryobject.stddev = childevent.stddev;
				WW_jssbusers[fromuserindex].downloadrecord[m] = summaryobject;
			}
			return;
		}
		if( requestflag == 3 )	{ // Unpack Download Events -- Overwrite previous ones
			var num = receivedevent.arraysize;
			WW_jssbusers[fromuserindex].numstatusrecords = num; // count status records
			WW_jssbusers[fromuserindex].statusrecord.length = num;
			WW_jssbusers[fromuserindex].statusrecordparms.todo0 = receivedevent.eventtodo0;
			WW_jssbusers[fromuserindex].statusrecordparms.todo1 = receivedevent.eventtodo1;
			WW_jssbusers[fromuserindex].statusrecordparms.todo2 = receivedevent.eventtodo2;
			WW_jssbusers[fromuserindex].statusrecordparms.todo3 = receivedevent.eventtodo3;
			WW_jssbusers[fromuserindex].statusrecordparms.eventct1 = receivedevent.eventct1;
			WW_jssbusers[fromuserindex].statusrecordparms.eventct2 = receivedevent.eventct2;
			WW_jssbusers[fromuserindex].statusrecordparms.eventct3 = receivedevent.eventct3;
			WW_jssbusers[fromuserindex].statusrecordparms.sourcetime = receivedevent.sourcetime;
			if(num <= 0 )
				return;
			for( var m=0; m<num; m++)	{
				var summaryobject = {};
				var childevent = receivedevent.arrayitself[m];
				summaryobject.sourceflag = childevent.sourceflag;
				summaryobject.sourcetime = childevent.sourcetime;
				summaryobject.targetminorevent = childevent.minorevent;
				summaryobject.message = childevent.message;
				summaryobject.tangogrouplabel = childevent.tangogrouplabel;
				summaryobject.tangosequencenumber = childevent.tangosequencenumber;
				summaryobject.infotype = childevent.infotype;
				summaryobject.targettime = childevent.targettime;
				summaryobject.eventtimingflag = childevent.eventtimingflag;
				if( childevent.eventtimingflag <= 1 )	{
					summaryobject.measuredtime = childevent.measuredtime;
					summaryobject.startmethod = childevent.startmethod;
					summaryobject.endmethod = childevent.endmethod;
				}
				else	{
					summaryobject.measuredtime = 0;
					summaryobject.startmethod = -1;
					summaryobject.endmethod = -1;
				}
				WW_jssbusers[fromuserindex].statusrecord[m] = summaryobject;
			}
			return;
		}
		return;

	}	// End Storing of Returned Data

// Generate data and return it to all users specified in sourcename of event or its children
// Ping only sent to sender
	if( requestflag > 3 )	{ // Generate Download Data and return nothing
		WW_seeifstatuswindowready(requestflag-3);
		return;
	}
	var wwevent = WW_geteventstatus(receivedevent);
	var touser = receivedevent.sourcename;
	var touserarray = new Array(touser);
	if( (requestflag>1) && WW_isdefined(receivedevent.arraysize))	{	// Add other recipients
		var num = receivedevent.arraysize;
		for( var m=0; m<num; m++)	{
			var possibility = receivedevent.arrayitself[m].sourcename;
			if(possibility == touser)
				continue;
			touserarray.push(possibility);
		}
	}	
	wwevent.targetname = touserarray.toString();
	var mess = WW_packevent(wwevent,WW_Eventtimename,WW_username + ' returning Probe back to ' + touser);
	Tango_selectiveSend(touserarray,mess);
	WW_sendaddcoloredhand(2);
	wwevent.majorevent = WW_numberurl;
	wwevent.minorevent = WW_numallevents+1;
	WW_eventrecord[WW_numallevents] = WW_cloneevent(wwevent);
	++WW_numallevents;
	return;
	
}	// End WW_readprobe(receivedevent)

function WW_storedownloaddata(wwevent)	{ // Store Download Data (timeprobeflag=2)

	var num = WW_jssbusers[0].numdownloads;
	if(num <= 0 )
		return;
	for( var m=0; m<num; m++)	{
		var summaryobject = WW_jssbusers[0].downloadrecord[m];
		var childevent = new WW_childevent('measuredtime');
		childevent.downloadlabel = summaryobject.label;
		childevent.timestarted = summaryobject.timestarted;
		childevent.average = summaryobject.average;
		childevent.stddev = summaryobject.stddev;
		wwevent.arrayitself[m] =childevent;
	}
	wwevent.arraysize = num;
	return;

}	// End WW_storedownloaddata(wwevent)

function WW_getlocalstatus()	{	// Generate Local status without Events Appearing anywhere

	var timeprobeevent = new WW_generatedevent(WW_username,WW_localnetflag,WW_controlgroup,WW_controlsequence,'measuredtime');
	timeprobeevent.timeprobeflag = -3;
	wwevent = WW_geteventstatus(timeprobeevent);
	wwevent.timeprobeflag = 3;
	WW_readprobe(wwevent);
	return;
	
}	// End WW_getlocalstatus()

// Make a measuredtime event
// timeprobeflag=1 Synchronization
// timeprobeflag=2 return downloaded image data timing
// timeprobeflag=3 return timing analysis of events

// eventtimingflag = 0 Completed event -- download time estimated
// = 1 Partial event -- time is current time
// = 2 Last Event Received
// = 3 Last Event Processed by JSSB
// = 4 Last DHTML Event Processed by WebWisdom Page
// For each event record download measuredtime if relevant
// Also sourceflag, tangogrouplabel, tangosequencenumber, sourcetime, targettime
//
// Overall Information is numbereventsanalysed (Total Number of events in Record)
// targettime that this analysis started and sourcetime on event requesting analysis
function WW_geteventstatus(timeprobeevent)	{

	var wwevent = new WW_returnevent();
	wwevent.type = 'measuredtime';
	wwevent.dispatchsourcetime = timeprobeevent.sourcetime;
	wwevent.tangogrouplabel = timeprobeevent.tangogrouplabel;
	wwevent.sourceflag = timeprobeevent.sourceflag;
	wwevent.tangosequencenumber = timeprobeevent.tangosequencenumber;
	wwevent.infotype = 7;
	wwevent.sourcename = WW_username;
	wwevent.dispatchsourcename = timeprobeevent.sourcename;
	wwevent.timeprobeflag = timeprobeevent.timeprobeflag;
	if( timeprobeevent.timeprobeflag == 1)	{ // Just a Ping
		return wwevent; }
	wwevent.arrayitself = new Array();
	wwevent.arraysize = 0;
	if( timeprobeevent.timeprobeflag == 2)	{ // Return Download Summary
		WW_storedownloaddata(wwevent);
		return wwevent;
	}
	wwevent.analyzedevents = 0;
	wwevent.eventct1 = WW_numallevents;
	wwevent.eventct2 = WW_numeventsdone;
	wwevent.eventct3 = WW_numpointereventsdone;
	if(WW_numallevents == 0)	{
		wwevent.eventtodo0 = 0;
		wwevent.eventtodo1 = 0;
		wwevent.eventtodo2 = 0;
		wwevent.eventtodo3 = 0;
		return wwevent; }
	var interestingev = WW_numallevents-1; // Skip this event itself
	if( timeprobeevent.timeprobeflag < 0 )
		interestingev = WW_numallevents; // Just Local
	var todo1=0;
	var todo2=0;
	var todo3=0;
	var todo0=0;
	if( WW_doublecheckonthis > 0 )
		todo0=1;
	for(var m=WW_numeventsdone; m < interestingev; m++)	{
		if(  WW_eventrecord[m].processed > 0 )
			continue;
		var evind = WW_eventrecord[m].infotype;
		if( (evind==0)||(evind==1) )
			++todo1;
		if( evind==2)
			++todo2;
	}
	for(var m=WW_numpointereventsdone; m < interestingev; m++)	{
		if(  WW_eventrecord[m].processed > 0 )
			continue;
		var evind = WW_eventrecord[m].infotype;
		if( evind==3 )
			++todo3;
	}
	wwevent.eventtodo0 = todo0;
	wwevent.eventtodo1 = todo1;
	wwevent.eventtodo2 = todo2;
	wwevent.eventtodo3 = todo3;
	if(interestingev > 0)	{
		var res =2;
		if( WW_numeventsdone >= interestingev )
			res =3;
		WW_loadtimedevent(wwevent,interestingev,res); }
	if( WW_numeventsdone < interestingev)
		WW_loadtimedevent(wwevent,WW_numeventsdone,3);
	if( (WW_numpointereventsdone>0) && (WW_numpointereventsdone < interestingev) )	{
		for( var m = WW_numpointereventsdone+1; m <interestingev; m++)	{
		if( m == WW_numeventsdone )
			continue;
		if( WW_eventrecord[m-1].infotype == 3 )	{
			WW_loadtimedevent(wwevent,m,4);
			break; }
		}
	}

//	Run through Event Indicators to Generate Download times
	if(WW_numeventindicators <= 0 )
		return wwevent;
	var resting = -1; // =m awaiting finishing of event started at Event Indicator m
	var rested = -1; // Finishing of Event at this event indicator
	var currentmajorevent = -1;
	var startmethod = -1;
	var endmethod= -1; // =1 next onunload; =2 next dynamic tango; =3 Wisdom onload; =4 Completed document
	for(var m=0; m<WW_numeventindicators ; m++)	{
		var tagobject = WW_eventindicators[m];
		var type = tagobject.type;
		var index = tagobject.index;

// Begin event with Preference Onunload(1); Dynamic Tango(2); in this preference order
// End of event -- end with Wisdom Page onload(6); Document Complete(10); Next "Certain Begin Event"
// i.e. Onunload; Dynamic Tango;
		if( resting < 0 )	{ // Await start of event
			if( type <= 2 )	{
				startmethod = type;
				resting =m;
				endmethod = -1;
				continue;
			}
			if( type == 7 )	{ // Major event is set on non master BEFORE begin event indicator
				currentmajorevent = index; // On master it is set AFTER  begin event indicator
				continue;
			}
			continue;
		}
		else	{ // In middle of event
			if( type == 7 )	{	// Major Event Set
				if( currentmajorevent >= 0 )	{
					if( rested < 0 )	{
						endmethod = 5;
						rested = m; }
					WW_analysetimedevent(currentmajorevent,resting,startmethod,rested,endmethod,wwevent);
					startmethod = -1;
					resting = -1;
					rested = -1;
					currentmajorevent = index;
					continue;
				}
				currentmajorevent = index; // Major Event Number being Timed
				continue;
			}
			if( type <= 2 )	{ // New event started in "middle" of old event
				if( (startmethod == 1)&& (type  == 2) )	{
					var tick1 = WW_eventindicators[resting].tickcount;
					var tick2 = WW_eventindicators[m].tickcount;
					if( (tick2-tick1) < 3 )
						continue;
				}
				if( rested < 0 ) {
					endmethod =type;
					rested = m;
				}
				if( currentmajorevent >= 0 )	{
					WW_analysetimedevent(currentmajorevent,resting,startmethod,rested,endmethod,wwevent);
				}
				startmethod = type;
				resting = m;
				rested = -1;
				currentmajorevent = -1;
				continue;
			}
			if( type == 6 )	{ // Certain End of Event Load
				if( currentmajorevent >= 0 )	{
					WW_analysetimedevent(currentmajorevent,resting,startmethod,m,3,wwevent);
				}
				startmethod = -1;
				resting = -1;
				rested = -1;
				currentmajorevent = -1;
				continue;
			}
			if( type == 10 )	{ // Possible End of Event due to completed document
				rested = m;
				endmethod = 4;
				continue;
			}
		}
	}
	if( (resting > 0) && (currentmajorevent >= 0 ) )	{ // Event waiting
		WW_analysetimedevent(currentmajorevent,resting,startmethod,rested,endmethod,wwevent);
	}
	return wwevent;
	
}	// End WW_geteventstatus(syncevent)

function WW_loadtimedevent(wwevent,evno,flag)	{

	if( evno <= 0 )
		return;
	var childevent = new WW_childevent('measuredtime');
	childevent.minorevent = evno;
	childevent.message = WW_eventrecord[evno-1].message;
	childevent.sourceflag = WW_eventrecord[evno-1].sourceflag;
	childevent.sourcetime = WW_eventrecord[evno-1].sourcetime;
	childevent.tangogrouplabel = WW_eventrecord[evno-1].tangogrouplabel;
	childevent.tangosequencenumber = WW_eventrecord[evno-1].tangosequencenumber;
	childevent.infotype = WW_eventrecord[evno-1].infotype;
	if(WW_isundefined(WW_eventrecord[evno-1].targettime))	{
		childevent.targettime = WW_eventrecord[evno-1].sourcetime;
	}
	else	{
		childevent.targettime = WW_eventrecord[evno-1].targettime;
	}
	childevent.eventtimingflag = flag;
	var m = wwevent.arraysize;
	wwevent.arrayitself[m] = childevent;
	wwevent.arraysize = m+1;
	wwevent.analyzedevents = m+1;
	return;

}	// End WW_loadtimedevent(wwevent,evno,flag)

//	Load Timing Data
// startmethod =1 Onunload of previous event; =2 Dynamic tango flag (within previous clock tick)
// endmethod =1 Onunload of next event; =2 Dynamic tango flag of next event(within previous clock tick)
// endmethod =3 Wisdom onload event; endmethod =4 Completed Document event
// endmethod = 5 Second Major event found before first satisfied
// Note Completed Document insists number of components is the same for 3 ( >0 components)
// to 6 clock cycles. Thus in this sense it overestimates completion time.
// However looking at pages with "onload" handler, this sometimes fires after completed document event
// So completed components is not end of page loading always
function WW_analysetimedevent(currentmajorevent,initialind,startmethod,finalind,endmethod,wwevent)	{

	var majorev = WW_majorevent[currentmajorevent];
	var m = wwevent.analyzedevents;
	var flag =0;
	if( finalind < 0 )
		flag = 1;
	WW_loadtimedevent(wwevent,majorev.associatedevent,flag);
	var storehere = wwevent.arrayitself[m];
	var initialtime = WW_eventindicators[initialind].time;
	var finaltime = wwevent.targettime; // Time at start of routine is default
	if( finalind > 0 )	{
		finaltime = WW_eventindicators[finalind].time; }
	storehere.measuredtime = finaltime-initialtime;
	storehere.startmethod = startmethod;
	storehere.endmethod = endmethod;
	return;

}	// End WW_analysetimedevent(currentmajorevent,initialind,startmethod,finalind,endmethod,wwevent)

function WW_analyzestatusevents()	{
	
	WW_getlocalstatus();	// Get Local Status
	
	for( var m=0; m < WW_numjssbusers; m++)	{
		var num = WW_jssbusers[m].numstatusrecords;
		if( num <= 0 )	{
			continue;
		}
		maxev = -1;
		maxevdone = -1;
		timedone = 0;
		for(var n=0; n< num; n++)	{
			var objecttouse = WW_jssbusers[m].statusrecord[n];
			var stofind = objecttouse.sourceflag + ""; // Find First minor event with these parameters
			var gtofind = objecttouse.tangogrouplabel + "";
			var ntofind = parseInt(objecttouse.tangosequencenumber);
			var localev = -1;
			for( var i=(WW_numallevents-1); i>=0; i--)	{
				var localobj = WW_eventrecord[i];
				if( (localobj.sourceflag+"") != stofind )
					continue;
				if( (localobj.tangogrouplabel+"") != gtofind )
					continue;
				var seq = parseInt(localobj.tangosequencenumber);
				if( seq == ntofind )	{
					localev = i;
					break; }
				if( seq < ntofind )
					break;
			}
			objecttouse.localeventpointer = localev; // -1 if no associated, otherwise argument of WW_eventrecord[]
			if( localev > maxev )
				maxev = localev;
			if( (objecttouse.eventtimingflag==0) && (localev > maxevdone) )	{
				maxevdone = localev;
				timedone = objecttouse.measuredtime;
			}
		}
		
		WW_jssbusers[m].statusrecordparms.maxeventno = maxev + 1;
		WW_jssbusers[m].statusrecordparms.maxeventdoneno = maxevdone + 1;
		WW_jssbusers[m].statusrecordparms.timeittook = timedone;

		for(var n=0; n< num; n++)	{ // Correct Events with eventtimingflag = 2 or 3
			var objecttouse = WW_jssbusers[m].statusrecord[n];
			if( (objecttouse.eventtimingflag !=2 ) && (objecttouse.eventtimingflag !=3 ) )
				continue;
			var localev = objecttouse.localeventpointer;
			if( localev < 0 )
				continue;
			for(var nn=0; nn< num; nn++)	{ // Try to find matching event
				var objecttouse1 = WW_jssbusers[m].statusrecord[nn];
				if( objecttouse1.eventtimingflag >= 2 )
					continue;
				if( objecttouse1.localeventpointer == localev )	{ // Match Found
					objecttouse.measuredtime = objecttouse1.measuredtime;
					objecttouse.startmethod = objecttouse1.startmethod;
					objecttouse.endmethod = objecttouse1.endmethod;
					break;
				}
			}
		}

	}	// End loop over participants
	return true;

}	// End WW_analyzestatusevents()

function WW_makeparticipantstatus()	{
	
	WW_getpingaverages();
	WW_analyzestatusevents();
	WW_statusoutput = 2;
	WW_statuswork = 0;
	if(WW_isitawindow(WW_statuswindow))	{
		if( WW_isdefined(WW_statuswindow.WW_pageloaded) )	{
			if( WW_statuswindow.WW_pageloaded == 1) 	{
				WW_statuswindow.WW_savestatusoutput = WW_statusoutput;
				WW_statuswindow.WW_savestatuswork = WW_statuswork;
				WW_statuswindow.WW_resizemethod();
				WW_statuswindow.focus();
				return true;
			}
		}
	}
	WW_button_Status();
	return;

}	// End WW_makeparticipantstatus()


function WW_summarizetimingstatus()	{

	WW_statusoutput = 1;
	WW_statuswork = 0;
	if(WW_isitawindow(WW_statuswindow))	{
		if( WW_isdefined(WW_statuswindow.WW_pageloaded) )	{
			if( WW_statuswindow.WW_pageloaded == 1) 	{
				WW_statuswindow.WW_savestatusoutput = WW_statusoutput;
				WW_statuswindow.WW_savestatuswork = WW_statuswork;
				WW_statuswindow.WW_resizemethod();
				WW_statuswindow.focus();
				return true;
			}
		}
	}
	WW_button_Status();
	return;

}	// End WW_summarizetimingstatus()

function WW_seeifstatuswindowready(iarg)	{

	if( WW_statusveto==0 )
		return;
	if(WW_isitawindow(WW_statuswindow))	{
		if( WW_isdefined(WW_statuswindow.WW_pageloaded) )	{
			if( WW_statuswindow.WW_pageloaded == 1) 	{
				WW_statuswindow.WW_dodownloadtest(iarg);	
				return true;
			}
		}
	}
	WW_statuswork = iarg;
	WW_statusoutput = 1;
	WW_button_Status();
	return true;

}	// End WW_seeifstatuswindowready(iarg)

// Find average Ping times
function WW_getpingaverages()	{

	for( var m=0; m <WW_numjssbusers; m++)	{
		var num = WW_jssbusers[m].numpings;
		if( num <= 0 )	{
			WW_jssbusers[m].lastping = 0;
			WW_jssbusers[m].averageping = 0;
			WW_jssbusers[m].averageskew = 0;
			continue;
		}
		var skew =0.;
		var ping = 0.;
		var junkn = new Array(-1,-1,-1,-1);
		var junkval = new Array (0.,0.,100000., 100000.);
		var nmin = num-14;
		if( nmin < 0 )
			nmin =0;
		if( num > 9 )	{ // Remove Outliers
			for( var n= (num-1); n>=nmin; n--)	{ // loop over pings finding outliers
				var val = WW_jssbusers[m].pingrecord[n].backtime - WW_jssbusers[m].pingrecord[n].sendtime;
				var nstore = n;
				if( val > junkval[0] )	{
					nstore = junkn[0];
					var valsave = junkval[0];
					junkn[0] = n;
					junkval[0] = val;
					val = valsave;
					continue; }
				if( nstore < 0 )
					continue;
				if( val > junkval[1] )	{
					var nsave = nstore;
					var valsave = val;
					nstore = junkn[1];
					val = junkval[1];
					junkn[1] = nsave;
					junkval[1] = valsave; 
					continue; }
				if( nstore < 0 )
					continue;
				if( val < junkval[3] )	{
					var nsave = nstore;
					nstore = junkn[3];
					var valsave = junkval[3];
					junkn[3] = nsave;
					junkval[3] = val;
					val = valsave;
					continue; }
				if( nstore < 0 )
					continue;
				if( val < junkval[2] )	{
					junkn[2] = nstore;
					junkval[2] = val; 
					continue; }	
			}
		}
		var nused =0;
		for( var n= (num-1); n>=nmin; n--)	{
			var nbad = false;
			for( var veto=0; veto < 4; veto++)	{
				if(junkn[veto] == n )	{
					nbad = true;
					continue;
				}
			}
			if( nbad )
				continue;
			++nused;
			skew += WW_jssbusers[m].pingrecord[n].arrivetime - 0.5*(WW_jssbusers[m].pingrecord[n].backtime + WW_jssbusers[m].pingrecord[n].sendtime);
			ping += (WW_jssbusers[m].pingrecord[n].backtime - WW_jssbusers[m].pingrecord[n].sendtime)*.5;
		}
		WW_jssbusers[m].lastping = (WW_jssbusers[m].pingrecord[num-1].backtime - WW_jssbusers[m].pingrecord[num-1].sendtime)*.5;
		WW_jssbusers[m].averageping = ping/nused;
		WW_jssbusers[m].averageskew = skew/nused;
	}

}	// end WW_getpingaverages()

// ************************ Game Material ***********************************
function WW_setgamestatus(newprogress,newgametype,playermoving)	{
	
	WW_mainurl = WW_defaultmainurl;
	if(WW_operatingmode < 3 )	{	
		return; }
	var nochange = true;
	if( (newprogress != WW_tangogameinprogress) || (newgametype != WW_tangogametypeloaded) )
		nochange = false;
	WW_tangogameinprogress = newprogress;
	WW_tangogametypeloaded = newgametype;
	if( WW_tangogameinprogress )	{
		if( (playermoving == 0) || (playermoving > 6 ) || (playermoving > WW_playernames.length) )
			WW_mainurl = 'gameon.gif';
		else	{
			WW_mainurl = 'gameon.gif';
			if( WW_username == WW_playernames[playermoving-1] )
				WW_mainurl = 'move' + playermoving + '.gif';
		}
	}
	if( nochange)
		return;
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writestatuslayer();
		WW_dialogwindow.WW_writegamelayer(); }
	return true;
	
}	// End WW_setgamestatus(newprogress,newgametype)
			
function WW_gameupdated(newprogress,newgametype,playermoving)	{

	WW_tangogameinprogress = newprogress;
	WW_tangogametypeloaded = newgametype;
	WW_mainurl = 'cardtable.gif';	
	if( WW_tangogameinprogress )	{
		if( (playermoving == 0) || (playermoving > 6 ) || (playermoving > WW_playernames.length) )
			WW_mainurl = 'gameon.gif';
		else	{
			WW_mainurl = 'gameon.gif';
			if( WW_username == WW_playernames[playermoving-1] )
				WW_mainurl = 'move' + playermoving + '.gif';
		}
	}
	if(WW_isitawindow(WW_dialogwindow))	{
		WW_dialogwindow.WW_writestatuslayer();
		WW_dialogwindow.WW_writegamelayer(); }
	return true;

}	// End WW_gameupdated()
